import Ember from 'ember';

export default Ember.Component.extend({
   tagName: 'g',
   bottle: null,
   nbRows:4,
   nbColumns:4,
   flipped: false,
   width: 100,
   height: 200,
   margin: 10,
   spacing: 10,
   bottleColor: '#22EE11',
   bottleFill: '#00AA00',
   bottleStrokeWidth: 2,
   bottleSize: 0.80,

   incX: Ember.computed('nbColumns', 'width', 'margin', 'spacing', function() {
      let usefulWidth = this.get('width') - 2*this.get('margin');
      return usefulWidth / this.get('nbColumns')/2;
   }),
   incY: Ember.computed('nbRows', 'height', 'margin', function() {
      let usefulHeight = this.get('height') - 2*this.get('margin');
      return usefulHeight / this.get('nbRows')/2;
   }),
   cx: Ember.computed('bottle', 'incX', 'margin', function() {
      let xcolumn = this.get('bottle').get('xcolumn');
      return this.get('margin')+this.get('incX')+xcolumn*2*this.get('incX');
   }),
   cy: Ember.computed('bottle', 'incY', 'margin', function() {
      let yrow = this.get('bottle').get('yrow');
      return this.get('margin')+this.get('incY')+yrow*2*this.get('incY');
   }),
   radius: Ember.computed('incX', 'incY', 'spacing', 'bottleSize', function() {
      return Math.min(this.get('incX') - this.get('spacing'), this.get('incY')) * this.get('bottleSize');
   })
});
