import Ember from 'ember';

export default Ember.Component.extend({
   id: 'rack',
   width: 800,
   height: 600,
   nbColumns: 4,
   nbRows: 4,
   tickSize: 8,
   margin: 10,
   spacing: 5,
   style: 1,
   bottles: null,

   frame: {
     frameBackgroundColor: '#DDDDDD',
     frameBorderColor: '#999999',
     frameBorderWidth: 3,
     frameCornerSize: 50,
     frameCornerShadow: true,
  },

  rack: {
     strokeColor: '#3322FF',
     strokeWidth: 3,
  },

  rackPath: Ember.computed('width', 'height', 'nbColumns', 'nbRows', 'margin', 'spacing', 'tickSize', function() {
     let bottles = this.get('bottles');
     for (var i=0; i<bottles.content.length;i++) {
        // pre-fetch data in relationship with rack (but do nothing with it :-())
        let bottle = bottles.objectAt(i);
        //console.log("Retrieve botlle "+bottle.get('name'));
     }
     let usefulWidth = this.get('width') - 2*this.get('margin');
     let usefulHeight = this.get('height') - 2*this.get('margin');
     let tick = this.get("tickSize");
     let incX = usefulWidth / this.get('nbColumns')/2;
     let incY = usefulHeight / this.get('nbRows')/2;
     let rayon = Math.min(incX - this.get('spacing'), incY);
     let line = "";
     for (var row=0; row < this.get('nbRows'); row++) {
        let cY = this.get('margin')+incY+row*2*incY;
        //line += "M "+this.get('rack.marginX')+" "+offsetY;
        for (var col=0; col < this.get('nbColumns'); col++) {
           let cX = this.get('margin')+incX+col*2*incX;
           line += "M "+(cX-tick)+" "+cY+" h "+2*tick+" M "+cX+" "+(cY-tick)+" v "+2*tick+" ";
           if (this.get('style')===1) {
             line += "M "+(cX-rayon)+" "+cY+ "a"+rayon+" "+rayon+" 0 0 0 "+2*rayon+" 0";
          }
        }
     }
     return line;
  })
});
