/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.model;

import aQute.bnd.annotation.ProviderType;

import com.liferay.expando.kernel.model.ExpandoBridge;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.kernel.model.BaseModel;
import com.liferay.portal.kernel.model.CacheModel;
import com.liferay.portal.kernel.model.GroupedModel;
import com.liferay.portal.kernel.model.ShardedModel;
import com.liferay.portal.kernel.model.StagedAuditedModel;
import com.liferay.portal.kernel.service.ServiceContext;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the Bottle service. Represents a row in the &quot;embercellar_Bottle&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link fr.ippon.services.embercellar.model.impl.BottleModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link fr.ippon.services.embercellar.model.impl.BottleImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see Bottle
 * @see fr.ippon.services.embercellar.model.impl.BottleImpl
 * @see fr.ippon.services.embercellar.model.impl.BottleModelImpl
 * @generated
 */
@ProviderType
public interface BottleModel extends BaseModel<Bottle>, GroupedModel,
	ShardedModel, StagedAuditedModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a bottle model instance should use the {@link Bottle} interface instead.
	 */

	/**
	 * Returns the primary key of this bottle.
	 *
	 * @return the primary key of this bottle
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this bottle.
	 *
	 * @param primaryKey the primary key of this bottle
	 */
	public void setPrimaryKey(long primaryKey);

	/**
	 * Returns the uuid of this bottle.
	 *
	 * @return the uuid of this bottle
	 */
	@AutoEscape
	@Override
	public String getUuid();

	/**
	 * Sets the uuid of this bottle.
	 *
	 * @param uuid the uuid of this bottle
	 */
	@Override
	public void setUuid(String uuid);

	/**
	 * Returns the bottle ID of this bottle.
	 *
	 * @return the bottle ID of this bottle
	 */
	public long getBottleId();

	/**
	 * Sets the bottle ID of this bottle.
	 *
	 * @param bottleId the bottle ID of this bottle
	 */
	public void setBottleId(long bottleId);

	/**
	 * Returns the group ID of this bottle.
	 *
	 * @return the group ID of this bottle
	 */
	@Override
	public long getGroupId();

	/**
	 * Sets the group ID of this bottle.
	 *
	 * @param groupId the group ID of this bottle
	 */
	@Override
	public void setGroupId(long groupId);

	/**
	 * Returns the company ID of this bottle.
	 *
	 * @return the company ID of this bottle
	 */
	@Override
	public long getCompanyId();

	/**
	 * Sets the company ID of this bottle.
	 *
	 * @param companyId the company ID of this bottle
	 */
	@Override
	public void setCompanyId(long companyId);

	/**
	 * Returns the user ID of this bottle.
	 *
	 * @return the user ID of this bottle
	 */
	@Override
	public long getUserId();

	/**
	 * Sets the user ID of this bottle.
	 *
	 * @param userId the user ID of this bottle
	 */
	@Override
	public void setUserId(long userId);

	/**
	 * Returns the user uuid of this bottle.
	 *
	 * @return the user uuid of this bottle
	 */
	@Override
	public String getUserUuid();

	/**
	 * Sets the user uuid of this bottle.
	 *
	 * @param userUuid the user uuid of this bottle
	 */
	@Override
	public void setUserUuid(String userUuid);

	/**
	 * Returns the user name of this bottle.
	 *
	 * @return the user name of this bottle
	 */
	@AutoEscape
	@Override
	public String getUserName();

	/**
	 * Sets the user name of this bottle.
	 *
	 * @param userName the user name of this bottle
	 */
	@Override
	public void setUserName(String userName);

	/**
	 * Returns the create date of this bottle.
	 *
	 * @return the create date of this bottle
	 */
	@Override
	public Date getCreateDate();

	/**
	 * Sets the create date of this bottle.
	 *
	 * @param createDate the create date of this bottle
	 */
	@Override
	public void setCreateDate(Date createDate);

	/**
	 * Returns the modified date of this bottle.
	 *
	 * @return the modified date of this bottle
	 */
	@Override
	public Date getModifiedDate();

	/**
	 * Sets the modified date of this bottle.
	 *
	 * @param modifiedDate the modified date of this bottle
	 */
	@Override
	public void setModifiedDate(Date modifiedDate);

	/**
	 * Returns the name of this bottle.
	 *
	 * @return the name of this bottle
	 */
	@AutoEscape
	public String getName();

	/**
	 * Sets the name of this bottle.
	 *
	 * @param name the name of this bottle
	 */
	public void setName(String name);

	/**
	 * Returns the flipped of this bottle.
	 *
	 * @return the flipped of this bottle
	 */
	public boolean getFlipped();

	/**
	 * Returns <code>true</code> if this bottle is flipped.
	 *
	 * @return <code>true</code> if this bottle is flipped; <code>false</code> otherwise
	 */
	public boolean isFlipped();

	/**
	 * Sets whether this bottle is flipped.
	 *
	 * @param flipped the flipped of this bottle
	 */
	public void setFlipped(boolean flipped);

	/**
	 * Returns the xcolumn of this bottle.
	 *
	 * @return the xcolumn of this bottle
	 */
	public int getXcolumn();

	/**
	 * Sets the xcolumn of this bottle.
	 *
	 * @param xcolumn the xcolumn of this bottle
	 */
	public void setXcolumn(int xcolumn);

	/**
	 * Returns the yrow of this bottle.
	 *
	 * @return the yrow of this bottle
	 */
	public int getYrow();

	/**
	 * Sets the yrow of this bottle.
	 *
	 * @param yrow the yrow of this bottle
	 */
	public void setYrow(int yrow);

	/**
	 * Returns the type of this bottle.
	 *
	 * @return the type of this bottle
	 */
	@AutoEscape
	public String getType();

	/**
	 * Sets the type of this bottle.
	 *
	 * @param type the type of this bottle
	 */
	public void setType(String type);

	/**
	 * Returns the rack ID of this bottle.
	 *
	 * @return the rack ID of this bottle
	 */
	public long getRackId();

	/**
	 * Sets the rack ID of this bottle.
	 *
	 * @param rackId the rack ID of this bottle
	 */
	public void setRackId(long rackId);

	@Override
	public boolean isNew();

	@Override
	public void setNew(boolean n);

	@Override
	public boolean isCachedModel();

	@Override
	public void setCachedModel(boolean cachedModel);

	@Override
	public boolean isEscapedModel();

	@Override
	public Serializable getPrimaryKeyObj();

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	@Override
	public ExpandoBridge getExpandoBridge();

	@Override
	public void setExpandoBridgeAttributes(BaseModel<?> baseModel);

	@Override
	public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge);

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	@Override
	public Object clone();

	@Override
	public int compareTo(fr.ippon.services.embercellar.model.Bottle bottle);

	@Override
	public int hashCode();

	@Override
	public CacheModel<fr.ippon.services.embercellar.model.Bottle> toCacheModel();

	@Override
	public fr.ippon.services.embercellar.model.Bottle toEscapedModel();

	@Override
	public fr.ippon.services.embercellar.model.Bottle toUnescapedModel();

	@Override
	public String toString();

	@Override
	public String toXmlString();
}