/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.model;

import aQute.bnd.annotation.ProviderType;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * This class is used by SOAP remote services, specifically {@link fr.ippon.services.embercellar.service.http.BottleServiceSoap}.
 *
 * @author Brian Wing Shun Chan
 * @see fr.ippon.services.embercellar.service.http.BottleServiceSoap
 * @generated
 */
@ProviderType
public class BottleSoap implements Serializable {
	public static BottleSoap toSoapModel(Bottle model) {
		BottleSoap soapModel = new BottleSoap();

		soapModel.setUuid(model.getUuid());
		soapModel.setBottleId(model.getBottleId());
		soapModel.setGroupId(model.getGroupId());
		soapModel.setCompanyId(model.getCompanyId());
		soapModel.setUserId(model.getUserId());
		soapModel.setUserName(model.getUserName());
		soapModel.setCreateDate(model.getCreateDate());
		soapModel.setModifiedDate(model.getModifiedDate());
		soapModel.setName(model.getName());
		soapModel.setFlipped(model.getFlipped());
		soapModel.setXcolumn(model.getXcolumn());
		soapModel.setYrow(model.getYrow());
		soapModel.setType(model.getType());
		soapModel.setRackId(model.getRackId());

		return soapModel;
	}

	public static BottleSoap[] toSoapModels(Bottle[] models) {
		BottleSoap[] soapModels = new BottleSoap[models.length];

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModel(models[i]);
		}

		return soapModels;
	}

	public static BottleSoap[][] toSoapModels(Bottle[][] models) {
		BottleSoap[][] soapModels = null;

		if (models.length > 0) {
			soapModels = new BottleSoap[models.length][models[0].length];
		}
		else {
			soapModels = new BottleSoap[0][0];
		}

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModels(models[i]);
		}

		return soapModels;
	}

	public static BottleSoap[] toSoapModels(List<Bottle> models) {
		List<BottleSoap> soapModels = new ArrayList<BottleSoap>(models.size());

		for (Bottle model : models) {
			soapModels.add(toSoapModel(model));
		}

		return soapModels.toArray(new BottleSoap[soapModels.size()]);
	}

	public BottleSoap() {
	}

	public long getPrimaryKey() {
		return _bottleId;
	}

	public void setPrimaryKey(long pk) {
		setBottleId(pk);
	}

	public String getUuid() {
		return _uuid;
	}

	public void setUuid(String uuid) {
		_uuid = uuid;
	}

	public long getBottleId() {
		return _bottleId;
	}

	public void setBottleId(long bottleId) {
		_bottleId = bottleId;
	}

	public long getGroupId() {
		return _groupId;
	}

	public void setGroupId(long groupId) {
		_groupId = groupId;
	}

	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public String getUserName() {
		return _userName;
	}

	public void setUserName(String userName) {
		_userName = userName;
	}

	public Date getCreateDate() {
		return _createDate;
	}

	public void setCreateDate(Date createDate) {
		_createDate = createDate;
	}

	public Date getModifiedDate() {
		return _modifiedDate;
	}

	public void setModifiedDate(Date modifiedDate) {
		_modifiedDate = modifiedDate;
	}

	public String getName() {
		return _name;
	}

	public void setName(String name) {
		_name = name;
	}

	public boolean getFlipped() {
		return _flipped;
	}

	public boolean isFlipped() {
		return _flipped;
	}

	public void setFlipped(boolean flipped) {
		_flipped = flipped;
	}

	public int getXcolumn() {
		return _xcolumn;
	}

	public void setXcolumn(int xcolumn) {
		_xcolumn = xcolumn;
	}

	public int getYrow() {
		return _yrow;
	}

	public void setYrow(int yrow) {
		_yrow = yrow;
	}

	public String getType() {
		return _type;
	}

	public void setType(String type) {
		_type = type;
	}

	public long getRackId() {
		return _rackId;
	}

	public void setRackId(long rackId) {
		_rackId = rackId;
	}

	private String _uuid;
	private long _bottleId;
	private long _groupId;
	private long _companyId;
	private long _userId;
	private String _userName;
	private Date _createDate;
	private Date _modifiedDate;
	private String _name;
	private boolean _flipped;
	private int _xcolumn;
	private int _yrow;
	private String _type;
	private long _rackId;
}