/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.model;

import aQute.bnd.annotation.ProviderType;

import com.liferay.expando.kernel.model.ExpandoBridge;

import com.liferay.exportimport.kernel.lar.StagedModelType;

import com.liferay.portal.kernel.model.ModelWrapper;
import com.liferay.portal.kernel.service.ServiceContext;

import java.io.Serializable;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

/**
 * <p>
 * This class is a wrapper for {@link Bottle}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see Bottle
 * @generated
 */
@ProviderType
public class BottleWrapper implements Bottle, ModelWrapper<Bottle> {
	public BottleWrapper(Bottle bottle) {
		_bottle = bottle;
	}

	@Override
	public Class<?> getModelClass() {
		return Bottle.class;
	}

	@Override
	public String getModelClassName() {
		return Bottle.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("uuid", getUuid());
		attributes.put("bottleId", getBottleId());
		attributes.put("groupId", getGroupId());
		attributes.put("companyId", getCompanyId());
		attributes.put("userId", getUserId());
		attributes.put("userName", getUserName());
		attributes.put("createDate", getCreateDate());
		attributes.put("modifiedDate", getModifiedDate());
		attributes.put("name", getName());
		attributes.put("flipped", getFlipped());
		attributes.put("xcolumn", getXcolumn());
		attributes.put("yrow", getYrow());
		attributes.put("type", getType());
		attributes.put("rackId", getRackId());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		String uuid = (String)attributes.get("uuid");

		if (uuid != null) {
			setUuid(uuid);
		}

		Long bottleId = (Long)attributes.get("bottleId");

		if (bottleId != null) {
			setBottleId(bottleId);
		}

		Long groupId = (Long)attributes.get("groupId");

		if (groupId != null) {
			setGroupId(groupId);
		}

		Long companyId = (Long)attributes.get("companyId");

		if (companyId != null) {
			setCompanyId(companyId);
		}

		Long userId = (Long)attributes.get("userId");

		if (userId != null) {
			setUserId(userId);
		}

		String userName = (String)attributes.get("userName");

		if (userName != null) {
			setUserName(userName);
		}

		Date createDate = (Date)attributes.get("createDate");

		if (createDate != null) {
			setCreateDate(createDate);
		}

		Date modifiedDate = (Date)attributes.get("modifiedDate");

		if (modifiedDate != null) {
			setModifiedDate(modifiedDate);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		Boolean flipped = (Boolean)attributes.get("flipped");

		if (flipped != null) {
			setFlipped(flipped);
		}

		Integer xcolumn = (Integer)attributes.get("xcolumn");

		if (xcolumn != null) {
			setXcolumn(xcolumn);
		}

		Integer yrow = (Integer)attributes.get("yrow");

		if (yrow != null) {
			setYrow(yrow);
		}

		String type = (String)attributes.get("type");

		if (type != null) {
			setType(type);
		}

		Long rackId = (Long)attributes.get("rackId");

		if (rackId != null) {
			setRackId(rackId);
		}
	}

	/**
	* Returns the flipped of this bottle.
	*
	* @return the flipped of this bottle
	*/
	@Override
	public boolean getFlipped() {
		return _bottle.getFlipped();
	}

	@Override
	public boolean isCachedModel() {
		return _bottle.isCachedModel();
	}

	@Override
	public boolean isEscapedModel() {
		return _bottle.isEscapedModel();
	}

	/**
	* Returns <code>true</code> if this bottle is flipped.
	*
	* @return <code>true</code> if this bottle is flipped; <code>false</code> otherwise
	*/
	@Override
	public boolean isFlipped() {
		return _bottle.isFlipped();
	}

	@Override
	public boolean isNew() {
		return _bottle.isNew();
	}

	@Override
	public ExpandoBridge getExpandoBridge() {
		return _bottle.getExpandoBridge();
	}

	@Override
	public com.liferay.portal.kernel.model.CacheModel<fr.ippon.services.embercellar.model.Bottle> toCacheModel() {
		return _bottle.toCacheModel();
	}

	@Override
	public fr.ippon.services.embercellar.model.Bottle toEscapedModel() {
		return new BottleWrapper(_bottle.toEscapedModel());
	}

	@Override
	public fr.ippon.services.embercellar.model.Bottle toUnescapedModel() {
		return new BottleWrapper(_bottle.toUnescapedModel());
	}

	@Override
	public int compareTo(fr.ippon.services.embercellar.model.Bottle bottle) {
		return _bottle.compareTo(bottle);
	}

	/**
	* Returns the xcolumn of this bottle.
	*
	* @return the xcolumn of this bottle
	*/
	@Override
	public int getXcolumn() {
		return _bottle.getXcolumn();
	}

	/**
	* Returns the yrow of this bottle.
	*
	* @return the yrow of this bottle
	*/
	@Override
	public int getYrow() {
		return _bottle.getYrow();
	}

	@Override
	public int hashCode() {
		return _bottle.hashCode();
	}

	@Override
	public Serializable getPrimaryKeyObj() {
		return _bottle.getPrimaryKeyObj();
	}

	@Override
	public java.lang.Object clone() {
		return new BottleWrapper((Bottle)_bottle.clone());
	}

	/**
	* Returns the name of this bottle.
	*
	* @return the name of this bottle
	*/
	@Override
	public java.lang.String getName() {
		return _bottle.getName();
	}

	/**
	* Returns the type of this bottle.
	*
	* @return the type of this bottle
	*/
	@Override
	public java.lang.String getType() {
		return _bottle.getType();
	}

	/**
	* Returns the user name of this bottle.
	*
	* @return the user name of this bottle
	*/
	@Override
	public java.lang.String getUserName() {
		return _bottle.getUserName();
	}

	/**
	* Returns the user uuid of this bottle.
	*
	* @return the user uuid of this bottle
	*/
	@Override
	public java.lang.String getUserUuid() {
		return _bottle.getUserUuid();
	}

	/**
	* Returns the uuid of this bottle.
	*
	* @return the uuid of this bottle
	*/
	@Override
	public java.lang.String getUuid() {
		return _bottle.getUuid();
	}

	@Override
	public java.lang.String toString() {
		return _bottle.toString();
	}

	@Override
	public java.lang.String toXmlString() {
		return _bottle.toXmlString();
	}

	/**
	* Returns the create date of this bottle.
	*
	* @return the create date of this bottle
	*/
	@Override
	public Date getCreateDate() {
		return _bottle.getCreateDate();
	}

	/**
	* Returns the modified date of this bottle.
	*
	* @return the modified date of this bottle
	*/
	@Override
	public Date getModifiedDate() {
		return _bottle.getModifiedDate();
	}

	/**
	* Returns the bottle ID of this bottle.
	*
	* @return the bottle ID of this bottle
	*/
	@Override
	public long getBottleId() {
		return _bottle.getBottleId();
	}

	/**
	* Returns the company ID of this bottle.
	*
	* @return the company ID of this bottle
	*/
	@Override
	public long getCompanyId() {
		return _bottle.getCompanyId();
	}

	/**
	* Returns the group ID of this bottle.
	*
	* @return the group ID of this bottle
	*/
	@Override
	public long getGroupId() {
		return _bottle.getGroupId();
	}

	/**
	* Returns the primary key of this bottle.
	*
	* @return the primary key of this bottle
	*/
	@Override
	public long getPrimaryKey() {
		return _bottle.getPrimaryKey();
	}

	/**
	* Returns the rack ID of this bottle.
	*
	* @return the rack ID of this bottle
	*/
	@Override
	public long getRackId() {
		return _bottle.getRackId();
	}

	/**
	* Returns the user ID of this bottle.
	*
	* @return the user ID of this bottle
	*/
	@Override
	public long getUserId() {
		return _bottle.getUserId();
	}

	@Override
	public void persist() {
		_bottle.persist();
	}

	/**
	* Sets the bottle ID of this bottle.
	*
	* @param bottleId the bottle ID of this bottle
	*/
	@Override
	public void setBottleId(long bottleId) {
		_bottle.setBottleId(bottleId);
	}

	@Override
	public void setCachedModel(boolean cachedModel) {
		_bottle.setCachedModel(cachedModel);
	}

	/**
	* Sets the company ID of this bottle.
	*
	* @param companyId the company ID of this bottle
	*/
	@Override
	public void setCompanyId(long companyId) {
		_bottle.setCompanyId(companyId);
	}

	/**
	* Sets the create date of this bottle.
	*
	* @param createDate the create date of this bottle
	*/
	@Override
	public void setCreateDate(Date createDate) {
		_bottle.setCreateDate(createDate);
	}

	@Override
	public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge) {
		_bottle.setExpandoBridgeAttributes(expandoBridge);
	}

	@Override
	public void setExpandoBridgeAttributes(
		com.liferay.portal.kernel.model.BaseModel<?> baseModel) {
		_bottle.setExpandoBridgeAttributes(baseModel);
	}

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		_bottle.setExpandoBridgeAttributes(serviceContext);
	}

	/**
	* Sets whether this bottle is flipped.
	*
	* @param flipped the flipped of this bottle
	*/
	@Override
	public void setFlipped(boolean flipped) {
		_bottle.setFlipped(flipped);
	}

	/**
	* Sets the group ID of this bottle.
	*
	* @param groupId the group ID of this bottle
	*/
	@Override
	public void setGroupId(long groupId) {
		_bottle.setGroupId(groupId);
	}

	/**
	* Sets the modified date of this bottle.
	*
	* @param modifiedDate the modified date of this bottle
	*/
	@Override
	public void setModifiedDate(Date modifiedDate) {
		_bottle.setModifiedDate(modifiedDate);
	}

	/**
	* Sets the name of this bottle.
	*
	* @param name the name of this bottle
	*/
	@Override
	public void setName(java.lang.String name) {
		_bottle.setName(name);
	}

	@Override
	public void setNew(boolean n) {
		_bottle.setNew(n);
	}

	/**
	* Sets the primary key of this bottle.
	*
	* @param primaryKey the primary key of this bottle
	*/
	@Override
	public void setPrimaryKey(long primaryKey) {
		_bottle.setPrimaryKey(primaryKey);
	}

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		_bottle.setPrimaryKeyObj(primaryKeyObj);
	}

	/**
	* Sets the rack ID of this bottle.
	*
	* @param rackId the rack ID of this bottle
	*/
	@Override
	public void setRackId(long rackId) {
		_bottle.setRackId(rackId);
	}

	/**
	* Sets the type of this bottle.
	*
	* @param type the type of this bottle
	*/
	@Override
	public void setType(java.lang.String type) {
		_bottle.setType(type);
	}

	/**
	* Sets the user ID of this bottle.
	*
	* @param userId the user ID of this bottle
	*/
	@Override
	public void setUserId(long userId) {
		_bottle.setUserId(userId);
	}

	/**
	* Sets the user name of this bottle.
	*
	* @param userName the user name of this bottle
	*/
	@Override
	public void setUserName(java.lang.String userName) {
		_bottle.setUserName(userName);
	}

	/**
	* Sets the user uuid of this bottle.
	*
	* @param userUuid the user uuid of this bottle
	*/
	@Override
	public void setUserUuid(java.lang.String userUuid) {
		_bottle.setUserUuid(userUuid);
	}

	/**
	* Sets the uuid of this bottle.
	*
	* @param uuid the uuid of this bottle
	*/
	@Override
	public void setUuid(java.lang.String uuid) {
		_bottle.setUuid(uuid);
	}

	/**
	* Sets the xcolumn of this bottle.
	*
	* @param xcolumn the xcolumn of this bottle
	*/
	@Override
	public void setXcolumn(int xcolumn) {
		_bottle.setXcolumn(xcolumn);
	}

	/**
	* Sets the yrow of this bottle.
	*
	* @param yrow the yrow of this bottle
	*/
	@Override
	public void setYrow(int yrow) {
		_bottle.setYrow(yrow);
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof BottleWrapper)) {
			return false;
		}

		BottleWrapper bottleWrapper = (BottleWrapper)obj;

		if (Objects.equals(_bottle, bottleWrapper._bottle)) {
			return true;
		}

		return false;
	}

	@Override
	public StagedModelType getStagedModelType() {
		return _bottle.getStagedModelType();
	}

	@Override
	public Bottle getWrappedModel() {
		return _bottle;
	}

	@Override
	public boolean isEntityCacheEnabled() {
		return _bottle.isEntityCacheEnabled();
	}

	@Override
	public boolean isFinderCacheEnabled() {
		return _bottle.isFinderCacheEnabled();
	}

	@Override
	public void resetOriginalValues() {
		_bottle.resetOriginalValues();
	}

	private final Bottle _bottle;
}