/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.model;

import aQute.bnd.annotation.ProviderType;

import com.liferay.portal.kernel.annotation.ImplementationClassName;
import com.liferay.portal.kernel.model.PersistedModel;
import com.liferay.portal.kernel.util.Accessor;

/**
 * The extended model interface for the Rack service. Represents a row in the &quot;embercellar_Rack&quot; database table, with each column mapped to a property of this class.
 *
 * @author Brian Wing Shun Chan
 * @see RackModel
 * @see fr.ippon.services.embercellar.model.impl.RackImpl
 * @see fr.ippon.services.embercellar.model.impl.RackModelImpl
 * @generated
 */
@ImplementationClassName("fr.ippon.services.embercellar.model.impl.RackImpl")
@ProviderType
public interface Rack extends RackModel, PersistedModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify this interface directly. Add methods to {@link fr.ippon.services.embercellar.model.impl.RackImpl} and rerun ServiceBuilder to automatically copy the method declarations to this interface.
	 */
	public static final Accessor<Rack, Long> RACK_ID_ACCESSOR = new Accessor<Rack, Long>() {
			@Override
			public Long get(Rack rack) {
				return rack.getRackId();
			}

			@Override
			public Class<Long> getAttributeClass() {
				return Long.class;
			}

			@Override
			public Class<Rack> getTypeClass() {
				return Rack.class;
			}
		};
}