/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.model;

import aQute.bnd.annotation.ProviderType;

import com.liferay.expando.kernel.model.ExpandoBridge;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.kernel.model.BaseModel;
import com.liferay.portal.kernel.model.CacheModel;
import com.liferay.portal.kernel.model.GroupedModel;
import com.liferay.portal.kernel.model.ShardedModel;
import com.liferay.portal.kernel.model.StagedAuditedModel;
import com.liferay.portal.kernel.service.ServiceContext;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the Rack service. Represents a row in the &quot;embercellar_Rack&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link fr.ippon.services.embercellar.model.impl.RackModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link fr.ippon.services.embercellar.model.impl.RackImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see Rack
 * @see fr.ippon.services.embercellar.model.impl.RackImpl
 * @see fr.ippon.services.embercellar.model.impl.RackModelImpl
 * @generated
 */
@ProviderType
public interface RackModel extends BaseModel<Rack>, GroupedModel, ShardedModel,
	StagedAuditedModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a rack model instance should use the {@link Rack} interface instead.
	 */

	/**
	 * Returns the primary key of this rack.
	 *
	 * @return the primary key of this rack
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this rack.
	 *
	 * @param primaryKey the primary key of this rack
	 */
	public void setPrimaryKey(long primaryKey);

	/**
	 * Returns the uuid of this rack.
	 *
	 * @return the uuid of this rack
	 */
	@AutoEscape
	@Override
	public String getUuid();

	/**
	 * Sets the uuid of this rack.
	 *
	 * @param uuid the uuid of this rack
	 */
	@Override
	public void setUuid(String uuid);

	/**
	 * Returns the rack ID of this rack.
	 *
	 * @return the rack ID of this rack
	 */
	public long getRackId();

	/**
	 * Sets the rack ID of this rack.
	 *
	 * @param rackId the rack ID of this rack
	 */
	public void setRackId(long rackId);

	/**
	 * Returns the group ID of this rack.
	 *
	 * @return the group ID of this rack
	 */
	@Override
	public long getGroupId();

	/**
	 * Sets the group ID of this rack.
	 *
	 * @param groupId the group ID of this rack
	 */
	@Override
	public void setGroupId(long groupId);

	/**
	 * Returns the company ID of this rack.
	 *
	 * @return the company ID of this rack
	 */
	@Override
	public long getCompanyId();

	/**
	 * Sets the company ID of this rack.
	 *
	 * @param companyId the company ID of this rack
	 */
	@Override
	public void setCompanyId(long companyId);

	/**
	 * Returns the user ID of this rack.
	 *
	 * @return the user ID of this rack
	 */
	@Override
	public long getUserId();

	/**
	 * Sets the user ID of this rack.
	 *
	 * @param userId the user ID of this rack
	 */
	@Override
	public void setUserId(long userId);

	/**
	 * Returns the user uuid of this rack.
	 *
	 * @return the user uuid of this rack
	 */
	@Override
	public String getUserUuid();

	/**
	 * Sets the user uuid of this rack.
	 *
	 * @param userUuid the user uuid of this rack
	 */
	@Override
	public void setUserUuid(String userUuid);

	/**
	 * Returns the user name of this rack.
	 *
	 * @return the user name of this rack
	 */
	@AutoEscape
	@Override
	public String getUserName();

	/**
	 * Sets the user name of this rack.
	 *
	 * @param userName the user name of this rack
	 */
	@Override
	public void setUserName(String userName);

	/**
	 * Returns the create date of this rack.
	 *
	 * @return the create date of this rack
	 */
	@Override
	public Date getCreateDate();

	/**
	 * Sets the create date of this rack.
	 *
	 * @param createDate the create date of this rack
	 */
	@Override
	public void setCreateDate(Date createDate);

	/**
	 * Returns the modified date of this rack.
	 *
	 * @return the modified date of this rack
	 */
	@Override
	public Date getModifiedDate();

	/**
	 * Sets the modified date of this rack.
	 *
	 * @param modifiedDate the modified date of this rack
	 */
	@Override
	public void setModifiedDate(Date modifiedDate);

	/**
	 * Returns the type of this rack.
	 *
	 * @return the type of this rack
	 */
	@AutoEscape
	public String getType();

	/**
	 * Sets the type of this rack.
	 *
	 * @param type the type of this rack
	 */
	public void setType(String type);

	/**
	 * Returns the name of this rack.
	 *
	 * @return the name of this rack
	 */
	@AutoEscape
	public String getName();

	/**
	 * Sets the name of this rack.
	 *
	 * @param name the name of this rack
	 */
	public void setName(String name);

	/**
	 * Returns the nb columns of this rack.
	 *
	 * @return the nb columns of this rack
	 */
	public int getNbColumns();

	/**
	 * Sets the nb columns of this rack.
	 *
	 * @param nbColumns the nb columns of this rack
	 */
	public void setNbColumns(int nbColumns);

	/**
	 * Returns the nb rows of this rack.
	 *
	 * @return the nb rows of this rack
	 */
	public int getNbRows();

	/**
	 * Sets the nb rows of this rack.
	 *
	 * @param nbRows the nb rows of this rack
	 */
	public void setNbRows(int nbRows);

	/**
	 * Returns the image of this rack.
	 *
	 * @return the image of this rack
	 */
	@AutoEscape
	public String getImage();

	/**
	 * Sets the image of this rack.
	 *
	 * @param image the image of this rack
	 */
	public void setImage(String image);

	/**
	 * Returns the bottles ID of this rack.
	 *
	 * @return the bottles ID of this rack
	 */
	@AutoEscape
	public String getBottlesId();

	/**
	 * Sets the bottles ID of this rack.
	 *
	 * @param bottlesId the bottles ID of this rack
	 */
	public void setBottlesId(String bottlesId);

	@Override
	public boolean isNew();

	@Override
	public void setNew(boolean n);

	@Override
	public boolean isCachedModel();

	@Override
	public void setCachedModel(boolean cachedModel);

	@Override
	public boolean isEscapedModel();

	@Override
	public Serializable getPrimaryKeyObj();

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	@Override
	public ExpandoBridge getExpandoBridge();

	@Override
	public void setExpandoBridgeAttributes(BaseModel<?> baseModel);

	@Override
	public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge);

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	@Override
	public Object clone();

	@Override
	public int compareTo(fr.ippon.services.embercellar.model.Rack rack);

	@Override
	public int hashCode();

	@Override
	public CacheModel<fr.ippon.services.embercellar.model.Rack> toCacheModel();

	@Override
	public fr.ippon.services.embercellar.model.Rack toEscapedModel();

	@Override
	public fr.ippon.services.embercellar.model.Rack toUnescapedModel();

	@Override
	public String toString();

	@Override
	public String toXmlString();
}