/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.model;

import aQute.bnd.annotation.ProviderType;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * This class is used by SOAP remote services, specifically {@link fr.ippon.services.embercellar.service.http.RackServiceSoap}.
 *
 * @author Brian Wing Shun Chan
 * @see fr.ippon.services.embercellar.service.http.RackServiceSoap
 * @generated
 */
@ProviderType
public class RackSoap implements Serializable {
	public static RackSoap toSoapModel(Rack model) {
		RackSoap soapModel = new RackSoap();

		soapModel.setUuid(model.getUuid());
		soapModel.setRackId(model.getRackId());
		soapModel.setGroupId(model.getGroupId());
		soapModel.setCompanyId(model.getCompanyId());
		soapModel.setUserId(model.getUserId());
		soapModel.setUserName(model.getUserName());
		soapModel.setCreateDate(model.getCreateDate());
		soapModel.setModifiedDate(model.getModifiedDate());
		soapModel.setType(model.getType());
		soapModel.setName(model.getName());
		soapModel.setNbColumns(model.getNbColumns());
		soapModel.setNbRows(model.getNbRows());
		soapModel.setImage(model.getImage());
		soapModel.setBottlesId(model.getBottlesId());

		return soapModel;
	}

	public static RackSoap[] toSoapModels(Rack[] models) {
		RackSoap[] soapModels = new RackSoap[models.length];

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModel(models[i]);
		}

		return soapModels;
	}

	public static RackSoap[][] toSoapModels(Rack[][] models) {
		RackSoap[][] soapModels = null;

		if (models.length > 0) {
			soapModels = new RackSoap[models.length][models[0].length];
		}
		else {
			soapModels = new RackSoap[0][0];
		}

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModels(models[i]);
		}

		return soapModels;
	}

	public static RackSoap[] toSoapModels(List<Rack> models) {
		List<RackSoap> soapModels = new ArrayList<RackSoap>(models.size());

		for (Rack model : models) {
			soapModels.add(toSoapModel(model));
		}

		return soapModels.toArray(new RackSoap[soapModels.size()]);
	}

	public RackSoap() {
	}

	public long getPrimaryKey() {
		return _rackId;
	}

	public void setPrimaryKey(long pk) {
		setRackId(pk);
	}

	public String getUuid() {
		return _uuid;
	}

	public void setUuid(String uuid) {
		_uuid = uuid;
	}

	public long getRackId() {
		return _rackId;
	}

	public void setRackId(long rackId) {
		_rackId = rackId;
	}

	public long getGroupId() {
		return _groupId;
	}

	public void setGroupId(long groupId) {
		_groupId = groupId;
	}

	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public String getUserName() {
		return _userName;
	}

	public void setUserName(String userName) {
		_userName = userName;
	}

	public Date getCreateDate() {
		return _createDate;
	}

	public void setCreateDate(Date createDate) {
		_createDate = createDate;
	}

	public Date getModifiedDate() {
		return _modifiedDate;
	}

	public void setModifiedDate(Date modifiedDate) {
		_modifiedDate = modifiedDate;
	}

	public String getType() {
		return _type;
	}

	public void setType(String type) {
		_type = type;
	}

	public String getName() {
		return _name;
	}

	public void setName(String name) {
		_name = name;
	}

	public int getNbColumns() {
		return _nbColumns;
	}

	public void setNbColumns(int nbColumns) {
		_nbColumns = nbColumns;
	}

	public int getNbRows() {
		return _nbRows;
	}

	public void setNbRows(int nbRows) {
		_nbRows = nbRows;
	}

	public String getImage() {
		return _image;
	}

	public void setImage(String image) {
		_image = image;
	}

	public String getBottlesId() {
		return _bottlesId;
	}

	public void setBottlesId(String bottlesId) {
		_bottlesId = bottlesId;
	}

	private String _uuid;
	private long _rackId;
	private long _groupId;
	private long _companyId;
	private long _userId;
	private String _userName;
	private Date _createDate;
	private Date _modifiedDate;
	private String _type;
	private String _name;
	private int _nbColumns;
	private int _nbRows;
	private String _image;
	private String _bottlesId;
}