/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.model;

import aQute.bnd.annotation.ProviderType;

import com.liferay.expando.kernel.model.ExpandoBridge;

import com.liferay.exportimport.kernel.lar.StagedModelType;

import com.liferay.portal.kernel.model.ModelWrapper;
import com.liferay.portal.kernel.service.ServiceContext;

import java.io.Serializable;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

/**
 * <p>
 * This class is a wrapper for {@link Rack}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see Rack
 * @generated
 */
@ProviderType
public class RackWrapper implements Rack, ModelWrapper<Rack> {
	public RackWrapper(Rack rack) {
		_rack = rack;
	}

	@Override
	public Class<?> getModelClass() {
		return Rack.class;
	}

	@Override
	public String getModelClassName() {
		return Rack.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("uuid", getUuid());
		attributes.put("rackId", getRackId());
		attributes.put("groupId", getGroupId());
		attributes.put("companyId", getCompanyId());
		attributes.put("userId", getUserId());
		attributes.put("userName", getUserName());
		attributes.put("createDate", getCreateDate());
		attributes.put("modifiedDate", getModifiedDate());
		attributes.put("type", getType());
		attributes.put("name", getName());
		attributes.put("nbColumns", getNbColumns());
		attributes.put("nbRows", getNbRows());
		attributes.put("image", getImage());
		attributes.put("bottlesId", getBottlesId());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		String uuid = (String)attributes.get("uuid");

		if (uuid != null) {
			setUuid(uuid);
		}

		Long rackId = (Long)attributes.get("rackId");

		if (rackId != null) {
			setRackId(rackId);
		}

		Long groupId = (Long)attributes.get("groupId");

		if (groupId != null) {
			setGroupId(groupId);
		}

		Long companyId = (Long)attributes.get("companyId");

		if (companyId != null) {
			setCompanyId(companyId);
		}

		Long userId = (Long)attributes.get("userId");

		if (userId != null) {
			setUserId(userId);
		}

		String userName = (String)attributes.get("userName");

		if (userName != null) {
			setUserName(userName);
		}

		Date createDate = (Date)attributes.get("createDate");

		if (createDate != null) {
			setCreateDate(createDate);
		}

		Date modifiedDate = (Date)attributes.get("modifiedDate");

		if (modifiedDate != null) {
			setModifiedDate(modifiedDate);
		}

		String type = (String)attributes.get("type");

		if (type != null) {
			setType(type);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		Integer nbColumns = (Integer)attributes.get("nbColumns");

		if (nbColumns != null) {
			setNbColumns(nbColumns);
		}

		Integer nbRows = (Integer)attributes.get("nbRows");

		if (nbRows != null) {
			setNbRows(nbRows);
		}

		String image = (String)attributes.get("image");

		if (image != null) {
			setImage(image);
		}

		String bottlesId = (String)attributes.get("bottlesId");

		if (bottlesId != null) {
			setBottlesId(bottlesId);
		}
	}

	@Override
	public boolean isCachedModel() {
		return _rack.isCachedModel();
	}

	@Override
	public boolean isEscapedModel() {
		return _rack.isEscapedModel();
	}

	@Override
	public boolean isNew() {
		return _rack.isNew();
	}

	@Override
	public ExpandoBridge getExpandoBridge() {
		return _rack.getExpandoBridge();
	}

	@Override
	public com.liferay.portal.kernel.model.CacheModel<fr.ippon.services.embercellar.model.Rack> toCacheModel() {
		return _rack.toCacheModel();
	}

	@Override
	public fr.ippon.services.embercellar.model.Rack toEscapedModel() {
		return new RackWrapper(_rack.toEscapedModel());
	}

	@Override
	public fr.ippon.services.embercellar.model.Rack toUnescapedModel() {
		return new RackWrapper(_rack.toUnescapedModel());
	}

	@Override
	public int compareTo(fr.ippon.services.embercellar.model.Rack rack) {
		return _rack.compareTo(rack);
	}

	/**
	* Returns the nb columns of this rack.
	*
	* @return the nb columns of this rack
	*/
	@Override
	public int getNbColumns() {
		return _rack.getNbColumns();
	}

	/**
	* Returns the nb rows of this rack.
	*
	* @return the nb rows of this rack
	*/
	@Override
	public int getNbRows() {
		return _rack.getNbRows();
	}

	@Override
	public int hashCode() {
		return _rack.hashCode();
	}

	@Override
	public Serializable getPrimaryKeyObj() {
		return _rack.getPrimaryKeyObj();
	}

	@Override
	public java.lang.Object clone() {
		return new RackWrapper((Rack)_rack.clone());
	}

	/**
	* Returns the bottles ID of this rack.
	*
	* @return the bottles ID of this rack
	*/
	@Override
	public java.lang.String getBottlesId() {
		return _rack.getBottlesId();
	}

	/**
	* Returns the image of this rack.
	*
	* @return the image of this rack
	*/
	@Override
	public java.lang.String getImage() {
		return _rack.getImage();
	}

	/**
	* Returns the name of this rack.
	*
	* @return the name of this rack
	*/
	@Override
	public java.lang.String getName() {
		return _rack.getName();
	}

	/**
	* Returns the type of this rack.
	*
	* @return the type of this rack
	*/
	@Override
	public java.lang.String getType() {
		return _rack.getType();
	}

	/**
	* Returns the user name of this rack.
	*
	* @return the user name of this rack
	*/
	@Override
	public java.lang.String getUserName() {
		return _rack.getUserName();
	}

	/**
	* Returns the user uuid of this rack.
	*
	* @return the user uuid of this rack
	*/
	@Override
	public java.lang.String getUserUuid() {
		return _rack.getUserUuid();
	}

	/**
	* Returns the uuid of this rack.
	*
	* @return the uuid of this rack
	*/
	@Override
	public java.lang.String getUuid() {
		return _rack.getUuid();
	}

	@Override
	public java.lang.String toString() {
		return _rack.toString();
	}

	@Override
	public java.lang.String toXmlString() {
		return _rack.toXmlString();
	}

	/**
	* Returns the create date of this rack.
	*
	* @return the create date of this rack
	*/
	@Override
	public Date getCreateDate() {
		return _rack.getCreateDate();
	}

	/**
	* Returns the modified date of this rack.
	*
	* @return the modified date of this rack
	*/
	@Override
	public Date getModifiedDate() {
		return _rack.getModifiedDate();
	}

	/**
	* Returns the company ID of this rack.
	*
	* @return the company ID of this rack
	*/
	@Override
	public long getCompanyId() {
		return _rack.getCompanyId();
	}

	/**
	* Returns the group ID of this rack.
	*
	* @return the group ID of this rack
	*/
	@Override
	public long getGroupId() {
		return _rack.getGroupId();
	}

	/**
	* Returns the primary key of this rack.
	*
	* @return the primary key of this rack
	*/
	@Override
	public long getPrimaryKey() {
		return _rack.getPrimaryKey();
	}

	/**
	* Returns the rack ID of this rack.
	*
	* @return the rack ID of this rack
	*/
	@Override
	public long getRackId() {
		return _rack.getRackId();
	}

	/**
	* Returns the user ID of this rack.
	*
	* @return the user ID of this rack
	*/
	@Override
	public long getUserId() {
		return _rack.getUserId();
	}

	@Override
	public void persist() {
		_rack.persist();
	}

	/**
	* Sets the bottles ID of this rack.
	*
	* @param bottlesId the bottles ID of this rack
	*/
	@Override
	public void setBottlesId(java.lang.String bottlesId) {
		_rack.setBottlesId(bottlesId);
	}

	@Override
	public void setCachedModel(boolean cachedModel) {
		_rack.setCachedModel(cachedModel);
	}

	/**
	* Sets the company ID of this rack.
	*
	* @param companyId the company ID of this rack
	*/
	@Override
	public void setCompanyId(long companyId) {
		_rack.setCompanyId(companyId);
	}

	/**
	* Sets the create date of this rack.
	*
	* @param createDate the create date of this rack
	*/
	@Override
	public void setCreateDate(Date createDate) {
		_rack.setCreateDate(createDate);
	}

	@Override
	public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge) {
		_rack.setExpandoBridgeAttributes(expandoBridge);
	}

	@Override
	public void setExpandoBridgeAttributes(
		com.liferay.portal.kernel.model.BaseModel<?> baseModel) {
		_rack.setExpandoBridgeAttributes(baseModel);
	}

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		_rack.setExpandoBridgeAttributes(serviceContext);
	}

	/**
	* Sets the group ID of this rack.
	*
	* @param groupId the group ID of this rack
	*/
	@Override
	public void setGroupId(long groupId) {
		_rack.setGroupId(groupId);
	}

	/**
	* Sets the image of this rack.
	*
	* @param image the image of this rack
	*/
	@Override
	public void setImage(java.lang.String image) {
		_rack.setImage(image);
	}

	/**
	* Sets the modified date of this rack.
	*
	* @param modifiedDate the modified date of this rack
	*/
	@Override
	public void setModifiedDate(Date modifiedDate) {
		_rack.setModifiedDate(modifiedDate);
	}

	/**
	* Sets the name of this rack.
	*
	* @param name the name of this rack
	*/
	@Override
	public void setName(java.lang.String name) {
		_rack.setName(name);
	}

	/**
	* Sets the nb columns of this rack.
	*
	* @param nbColumns the nb columns of this rack
	*/
	@Override
	public void setNbColumns(int nbColumns) {
		_rack.setNbColumns(nbColumns);
	}

	/**
	* Sets the nb rows of this rack.
	*
	* @param nbRows the nb rows of this rack
	*/
	@Override
	public void setNbRows(int nbRows) {
		_rack.setNbRows(nbRows);
	}

	@Override
	public void setNew(boolean n) {
		_rack.setNew(n);
	}

	/**
	* Sets the primary key of this rack.
	*
	* @param primaryKey the primary key of this rack
	*/
	@Override
	public void setPrimaryKey(long primaryKey) {
		_rack.setPrimaryKey(primaryKey);
	}

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		_rack.setPrimaryKeyObj(primaryKeyObj);
	}

	/**
	* Sets the rack ID of this rack.
	*
	* @param rackId the rack ID of this rack
	*/
	@Override
	public void setRackId(long rackId) {
		_rack.setRackId(rackId);
	}

	/**
	* Sets the type of this rack.
	*
	* @param type the type of this rack
	*/
	@Override
	public void setType(java.lang.String type) {
		_rack.setType(type);
	}

	/**
	* Sets the user ID of this rack.
	*
	* @param userId the user ID of this rack
	*/
	@Override
	public void setUserId(long userId) {
		_rack.setUserId(userId);
	}

	/**
	* Sets the user name of this rack.
	*
	* @param userName the user name of this rack
	*/
	@Override
	public void setUserName(java.lang.String userName) {
		_rack.setUserName(userName);
	}

	/**
	* Sets the user uuid of this rack.
	*
	* @param userUuid the user uuid of this rack
	*/
	@Override
	public void setUserUuid(java.lang.String userUuid) {
		_rack.setUserUuid(userUuid);
	}

	/**
	* Sets the uuid of this rack.
	*
	* @param uuid the uuid of this rack
	*/
	@Override
	public void setUuid(java.lang.String uuid) {
		_rack.setUuid(uuid);
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof RackWrapper)) {
			return false;
		}

		RackWrapper rackWrapper = (RackWrapper)obj;

		if (Objects.equals(_rack, rackWrapper._rack)) {
			return true;
		}

		return false;
	}

	@Override
	public StagedModelType getStagedModelType() {
		return _rack.getStagedModelType();
	}

	@Override
	public Rack getWrappedModel() {
		return _rack;
	}

	@Override
	public boolean isEntityCacheEnabled() {
		return _rack.isEntityCacheEnabled();
	}

	@Override
	public boolean isFinderCacheEnabled() {
		return _rack.isFinderCacheEnabled();
	}

	@Override
	public void resetOriginalValues() {
		_rack.resetOriginalValues();
	}

	private final Rack _rack;
}