/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.service;

import aQute.bnd.annotation.ProviderType;

import com.liferay.osgi.util.ServiceTrackerFactory;

import org.osgi.util.tracker.ServiceTracker;

/**
 * Provides the local service utility for Bottle. This utility wraps
 * {@link fr.ippon.services.embercellar.service.impl.BottleLocalServiceImpl} and is the
 * primary access point for service operations in application layer code running
 * on the local server. Methods of this service will not have security checks
 * based on the propagated JAAS credentials because this service can only be
 * accessed from within the same VM.
 *
 * @author Brian Wing Shun Chan
 * @see BottleLocalService
 * @see fr.ippon.services.embercellar.service.base.BottleLocalServiceBaseImpl
 * @see fr.ippon.services.embercellar.service.impl.BottleLocalServiceImpl
 * @generated
 */
@ProviderType
public class BottleLocalServiceUtil {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify this class directly. Add custom service methods to {@link fr.ippon.services.embercellar.service.impl.BottleLocalServiceImpl} and rerun ServiceBuilder to regenerate this class.
	 */
	public static com.liferay.portal.kernel.dao.orm.ActionableDynamicQuery getActionableDynamicQuery() {
		return getService().getActionableDynamicQuery();
	}

	public static com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery() {
		return getService().dynamicQuery();
	}

	public static com.liferay.portal.kernel.dao.orm.ExportActionableDynamicQuery getExportActionableDynamicQuery(
		com.liferay.exportimport.kernel.lar.PortletDataContext portletDataContext) {
		return getService().getExportActionableDynamicQuery(portletDataContext);
	}

	public static com.liferay.portal.kernel.dao.orm.IndexableActionableDynamicQuery getIndexableActionableDynamicQuery() {
		return getService().getIndexableActionableDynamicQuery();
	}

	/**
	* @throws PortalException
	*/
	public static com.liferay.portal.kernel.model.PersistedModel deletePersistedModel(
		com.liferay.portal.kernel.model.PersistedModel persistedModel)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().deletePersistedModel(persistedModel);
	}

	public static com.liferay.portal.kernel.model.PersistedModel getPersistedModel(
		java.io.Serializable primaryKeyObj)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().getPersistedModel(primaryKeyObj);
	}

	/**
	* Adds the bottle to the database. Also notifies the appropriate model listeners.
	*
	* @param bottle the bottle
	* @return the bottle that was added
	*/
	public static fr.ippon.services.embercellar.model.Bottle addBottle(
		fr.ippon.services.embercellar.model.Bottle bottle) {
		return getService().addBottle(bottle);
	}

	public static fr.ippon.services.embercellar.model.Bottle addBottle(
		long userId, long groupId, java.lang.String name, int column, int row,
		boolean flipped, long rackId,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.NoSuchUserException {
		return getService()
				   .addBottle(userId, groupId, name, column, row, flipped,
			rackId, serviceContext);
	}

	/**
	* Creates a new bottle with the primary key. Does not add the bottle to the database.
	*
	* @param bottleId the primary key for the new bottle
	* @return the new bottle
	*/
	public static fr.ippon.services.embercellar.model.Bottle createBottle(
		long bottleId) {
		return getService().createBottle(bottleId);
	}

	/**
	* Deletes the bottle from the database. Also notifies the appropriate model listeners.
	*
	* @param bottle the bottle
	* @return the bottle that was removed
	*/
	public static fr.ippon.services.embercellar.model.Bottle deleteBottle(
		fr.ippon.services.embercellar.model.Bottle bottle) {
		return getService().deleteBottle(bottle);
	}

	/**
	* Deletes the bottle with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param bottleId the primary key of the bottle
	* @return the bottle that was removed
	* @throws PortalException if a bottle with the primary key could not be found
	*/
	public static fr.ippon.services.embercellar.model.Bottle deleteBottle(
		long bottleId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().deleteBottle(bottleId);
	}

	public static fr.ippon.services.embercellar.model.Bottle fetchBottle(
		long bottleId) {
		return getService().fetchBottle(bottleId);
	}

	/**
	* Returns the bottle matching the UUID and group.
	*
	* @param uuid the bottle's UUID
	* @param groupId the primary key of the group
	* @return the matching bottle, or <code>null</code> if a matching bottle could not be found
	*/
	public static fr.ippon.services.embercellar.model.Bottle fetchBottleByUuidAndGroupId(
		java.lang.String uuid, long groupId) {
		return getService().fetchBottleByUuidAndGroupId(uuid, groupId);
	}

	/**
	* Returns the bottle with the primary key.
	*
	* @param bottleId the primary key of the bottle
	* @return the bottle
	* @throws PortalException if a bottle with the primary key could not be found
	*/
	public static fr.ippon.services.embercellar.model.Bottle getBottle(
		long bottleId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().getBottle(bottleId);
	}

	/**
	* Returns the bottle matching the UUID and group.
	*
	* @param uuid the bottle's UUID
	* @param groupId the primary key of the group
	* @return the matching bottle
	* @throws PortalException if a matching bottle could not be found
	*/
	public static fr.ippon.services.embercellar.model.Bottle getBottleByUuidAndGroupId(
		java.lang.String uuid, long groupId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().getBottleByUuidAndGroupId(uuid, groupId);
	}

	/**
	* Updates the bottle in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	*
	* @param bottle the bottle
	* @return the bottle that was updated
	*/
	public static fr.ippon.services.embercellar.model.Bottle updateBottle(
		fr.ippon.services.embercellar.model.Bottle bottle) {
		return getService().updateBottle(bottle);
	}

	/**
	* Returns the number of bottles.
	*
	* @return the number of bottles
	*/
	public static int getBottlesCount() {
		return getService().getBottlesCount();
	}

	/**
	* Returns the OSGi service identifier.
	*
	* @return the OSGi service identifier
	*/
	public static java.lang.String getOSGiServiceIdentifier() {
		return getService().getOSGiServiceIdentifier();
	}

	/**
	* Performs a dynamic query on the database and returns the matching rows.
	*
	* @param dynamicQuery the dynamic query
	* @return the matching rows
	*/
	public static <T> java.util.List<T> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery) {
		return getService().dynamicQuery(dynamicQuery);
	}

	/**
	* Performs a dynamic query on the database and returns a range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link fr.ippon.services.embercellar.model.impl.BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @return the range of matching rows
	*/
	public static <T> java.util.List<T> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) {
		return getService().dynamicQuery(dynamicQuery, start, end);
	}

	/**
	* Performs a dynamic query on the database and returns an ordered range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link fr.ippon.services.embercellar.model.impl.BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching rows
	*/
	public static <T> java.util.List<T> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator<T> orderByComparator) {
		return getService()
				   .dynamicQuery(dynamicQuery, start, end, orderByComparator);
	}

	public static java.util.List<fr.ippon.services.embercellar.model.Bottle> findAll() {
		return getService().findAll();
	}

	/**
	* NOTE FOR DEVELOPERS:
	*
	* Never reference this class directly. Always use {@link fr.ippon.services.embercellar.service.BottleLocalServiceUtil} to access the bottle local service.
	*/
	public static java.util.List<fr.ippon.services.embercellar.model.Bottle> findByRackId(
		long rackId) {
		return getService().findByRackId(rackId);
	}

	/**
	* Returns a range of all the bottles.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link fr.ippon.services.embercellar.model.impl.BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @return the range of bottles
	*/
	public static java.util.List<fr.ippon.services.embercellar.model.Bottle> getBottles(
		int start, int end) {
		return getService().getBottles(start, end);
	}

	/**
	* Returns all the bottles matching the UUID and company.
	*
	* @param uuid the UUID of the bottles
	* @param companyId the primary key of the company
	* @return the matching bottles, or an empty list if no matches were found
	*/
	public static java.util.List<fr.ippon.services.embercellar.model.Bottle> getBottlesByUuidAndCompanyId(
		java.lang.String uuid, long companyId) {
		return getService().getBottlesByUuidAndCompanyId(uuid, companyId);
	}

	/**
	* Returns a range of bottles matching the UUID and company.
	*
	* @param uuid the UUID of the bottles
	* @param companyId the primary key of the company
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the range of matching bottles, or an empty list if no matches were found
	*/
	public static java.util.List<fr.ippon.services.embercellar.model.Bottle> getBottlesByUuidAndCompanyId(
		java.lang.String uuid, long companyId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator<fr.ippon.services.embercellar.model.Bottle> orderByComparator) {
		return getService()
				   .getBottlesByUuidAndCompanyId(uuid, companyId, start, end,
			orderByComparator);
	}

	/**
	* Returns the number of rows matching the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @return the number of rows matching the dynamic query
	*/
	public static long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery) {
		return getService().dynamicQueryCount(dynamicQuery);
	}

	/**
	* Returns the number of rows matching the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @param projection the projection to apply to the query
	* @return the number of rows matching the dynamic query
	*/
	public static long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery,
		com.liferay.portal.kernel.dao.orm.Projection projection) {
		return getService().dynamicQueryCount(dynamicQuery, projection);
	}

	public static BottleLocalService getService() {
		return _serviceTracker.getService();
	}

	private static ServiceTracker<BottleLocalService, BottleLocalService> _serviceTracker =
		ServiceTrackerFactory.open(BottleLocalService.class);
}