/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.service;

import aQute.bnd.annotation.ProviderType;

import com.liferay.portal.kernel.service.ServiceWrapper;

/**
 * Provides a wrapper for {@link BottleLocalService}.
 *
 * @author Brian Wing Shun Chan
 * @see BottleLocalService
 * @generated
 */
@ProviderType
public class BottleLocalServiceWrapper implements BottleLocalService,
	ServiceWrapper<BottleLocalService> {
	public BottleLocalServiceWrapper(BottleLocalService bottleLocalService) {
		_bottleLocalService = bottleLocalService;
	}

	@Override
	public com.liferay.portal.kernel.dao.orm.ActionableDynamicQuery getActionableDynamicQuery() {
		return _bottleLocalService.getActionableDynamicQuery();
	}

	@Override
	public com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery() {
		return _bottleLocalService.dynamicQuery();
	}

	@Override
	public com.liferay.portal.kernel.dao.orm.ExportActionableDynamicQuery getExportActionableDynamicQuery(
		com.liferay.exportimport.kernel.lar.PortletDataContext portletDataContext) {
		return _bottleLocalService.getExportActionableDynamicQuery(portletDataContext);
	}

	@Override
	public com.liferay.portal.kernel.dao.orm.IndexableActionableDynamicQuery getIndexableActionableDynamicQuery() {
		return _bottleLocalService.getIndexableActionableDynamicQuery();
	}

	/**
	* @throws PortalException
	*/
	@Override
	public com.liferay.portal.kernel.model.PersistedModel deletePersistedModel(
		com.liferay.portal.kernel.model.PersistedModel persistedModel)
		throws com.liferay.portal.kernel.exception.PortalException {
		return _bottleLocalService.deletePersistedModel(persistedModel);
	}

	@Override
	public com.liferay.portal.kernel.model.PersistedModel getPersistedModel(
		java.io.Serializable primaryKeyObj)
		throws com.liferay.portal.kernel.exception.PortalException {
		return _bottleLocalService.getPersistedModel(primaryKeyObj);
	}

	/**
	* Adds the bottle to the database. Also notifies the appropriate model listeners.
	*
	* @param bottle the bottle
	* @return the bottle that was added
	*/
	@Override
	public fr.ippon.services.embercellar.model.Bottle addBottle(
		fr.ippon.services.embercellar.model.Bottle bottle) {
		return _bottleLocalService.addBottle(bottle);
	}

	@Override
	public fr.ippon.services.embercellar.model.Bottle addBottle(long userId,
		long groupId, java.lang.String name, int column, int row,
		boolean flipped, long rackId,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.NoSuchUserException {
		return _bottleLocalService.addBottle(userId, groupId, name, column,
			row, flipped, rackId, serviceContext);
	}

	/**
	* Creates a new bottle with the primary key. Does not add the bottle to the database.
	*
	* @param bottleId the primary key for the new bottle
	* @return the new bottle
	*/
	@Override
	public fr.ippon.services.embercellar.model.Bottle createBottle(
		long bottleId) {
		return _bottleLocalService.createBottle(bottleId);
	}

	/**
	* Deletes the bottle from the database. Also notifies the appropriate model listeners.
	*
	* @param bottle the bottle
	* @return the bottle that was removed
	*/
	@Override
	public fr.ippon.services.embercellar.model.Bottle deleteBottle(
		fr.ippon.services.embercellar.model.Bottle bottle) {
		return _bottleLocalService.deleteBottle(bottle);
	}

	/**
	* Deletes the bottle with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param bottleId the primary key of the bottle
	* @return the bottle that was removed
	* @throws PortalException if a bottle with the primary key could not be found
	*/
	@Override
	public fr.ippon.services.embercellar.model.Bottle deleteBottle(
		long bottleId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return _bottleLocalService.deleteBottle(bottleId);
	}

	@Override
	public fr.ippon.services.embercellar.model.Bottle fetchBottle(long bottleId) {
		return _bottleLocalService.fetchBottle(bottleId);
	}

	/**
	* Returns the bottle matching the UUID and group.
	*
	* @param uuid the bottle's UUID
	* @param groupId the primary key of the group
	* @return the matching bottle, or <code>null</code> if a matching bottle could not be found
	*/
	@Override
	public fr.ippon.services.embercellar.model.Bottle fetchBottleByUuidAndGroupId(
		java.lang.String uuid, long groupId) {
		return _bottleLocalService.fetchBottleByUuidAndGroupId(uuid, groupId);
	}

	/**
	* Returns the bottle with the primary key.
	*
	* @param bottleId the primary key of the bottle
	* @return the bottle
	* @throws PortalException if a bottle with the primary key could not be found
	*/
	@Override
	public fr.ippon.services.embercellar.model.Bottle getBottle(long bottleId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return _bottleLocalService.getBottle(bottleId);
	}

	/**
	* Returns the bottle matching the UUID and group.
	*
	* @param uuid the bottle's UUID
	* @param groupId the primary key of the group
	* @return the matching bottle
	* @throws PortalException if a matching bottle could not be found
	*/
	@Override
	public fr.ippon.services.embercellar.model.Bottle getBottleByUuidAndGroupId(
		java.lang.String uuid, long groupId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return _bottleLocalService.getBottleByUuidAndGroupId(uuid, groupId);
	}

	/**
	* Updates the bottle in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	*
	* @param bottle the bottle
	* @return the bottle that was updated
	*/
	@Override
	public fr.ippon.services.embercellar.model.Bottle updateBottle(
		fr.ippon.services.embercellar.model.Bottle bottle) {
		return _bottleLocalService.updateBottle(bottle);
	}

	/**
	* Returns the number of bottles.
	*
	* @return the number of bottles
	*/
	@Override
	public int getBottlesCount() {
		return _bottleLocalService.getBottlesCount();
	}

	/**
	* Returns the OSGi service identifier.
	*
	* @return the OSGi service identifier
	*/
	@Override
	public java.lang.String getOSGiServiceIdentifier() {
		return _bottleLocalService.getOSGiServiceIdentifier();
	}

	/**
	* Performs a dynamic query on the database and returns the matching rows.
	*
	* @param dynamicQuery the dynamic query
	* @return the matching rows
	*/
	@Override
	public <T> java.util.List<T> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery) {
		return _bottleLocalService.dynamicQuery(dynamicQuery);
	}

	/**
	* Performs a dynamic query on the database and returns a range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link fr.ippon.services.embercellar.model.impl.BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @return the range of matching rows
	*/
	@Override
	public <T> java.util.List<T> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) {
		return _bottleLocalService.dynamicQuery(dynamicQuery, start, end);
	}

	/**
	* Performs a dynamic query on the database and returns an ordered range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link fr.ippon.services.embercellar.model.impl.BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching rows
	*/
	@Override
	public <T> java.util.List<T> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator<T> orderByComparator) {
		return _bottleLocalService.dynamicQuery(dynamicQuery, start, end,
			orderByComparator);
	}

	@Override
	public java.util.List<fr.ippon.services.embercellar.model.Bottle> findAll() {
		return _bottleLocalService.findAll();
	}

	/**
	* NOTE FOR DEVELOPERS:
	*
	* Never reference this class directly. Always use {@link fr.ippon.services.embercellar.service.BottleLocalServiceUtil} to access the bottle local service.
	*/
	@Override
	public java.util.List<fr.ippon.services.embercellar.model.Bottle> findByRackId(
		long rackId) {
		return _bottleLocalService.findByRackId(rackId);
	}

	/**
	* Returns a range of all the bottles.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link fr.ippon.services.embercellar.model.impl.BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @return the range of bottles
	*/
	@Override
	public java.util.List<fr.ippon.services.embercellar.model.Bottle> getBottles(
		int start, int end) {
		return _bottleLocalService.getBottles(start, end);
	}

	/**
	* Returns all the bottles matching the UUID and company.
	*
	* @param uuid the UUID of the bottles
	* @param companyId the primary key of the company
	* @return the matching bottles, or an empty list if no matches were found
	*/
	@Override
	public java.util.List<fr.ippon.services.embercellar.model.Bottle> getBottlesByUuidAndCompanyId(
		java.lang.String uuid, long companyId) {
		return _bottleLocalService.getBottlesByUuidAndCompanyId(uuid, companyId);
	}

	/**
	* Returns a range of bottles matching the UUID and company.
	*
	* @param uuid the UUID of the bottles
	* @param companyId the primary key of the company
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the range of matching bottles, or an empty list if no matches were found
	*/
	@Override
	public java.util.List<fr.ippon.services.embercellar.model.Bottle> getBottlesByUuidAndCompanyId(
		java.lang.String uuid, long companyId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator<fr.ippon.services.embercellar.model.Bottle> orderByComparator) {
		return _bottleLocalService.getBottlesByUuidAndCompanyId(uuid,
			companyId, start, end, orderByComparator);
	}

	/**
	* Returns the number of rows matching the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @return the number of rows matching the dynamic query
	*/
	@Override
	public long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery) {
		return _bottleLocalService.dynamicQueryCount(dynamicQuery);
	}

	/**
	* Returns the number of rows matching the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @param projection the projection to apply to the query
	* @return the number of rows matching the dynamic query
	*/
	@Override
	public long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery,
		com.liferay.portal.kernel.dao.orm.Projection projection) {
		return _bottleLocalService.dynamicQueryCount(dynamicQuery, projection);
	}

	@Override
	public BottleLocalService getWrappedService() {
		return _bottleLocalService;
	}

	@Override
	public void setWrappedService(BottleLocalService bottleLocalService) {
		_bottleLocalService = bottleLocalService;
	}

	private BottleLocalService _bottleLocalService;
}