/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.service;

import aQute.bnd.annotation.ProviderType;

import com.liferay.osgi.util.ServiceTrackerFactory;

import org.osgi.util.tracker.ServiceTracker;

/**
 * Provides the remote service utility for Bottle. This utility wraps
 * {@link fr.ippon.services.embercellar.service.impl.BottleServiceImpl} and is the
 * primary access point for service operations in application layer code running
 * on a remote server. Methods of this service are expected to have security
 * checks based on the propagated JAAS credentials because this service can be
 * accessed remotely.
 *
 * @author Brian Wing Shun Chan
 * @see BottleService
 * @see fr.ippon.services.embercellar.service.base.BottleServiceBaseImpl
 * @see fr.ippon.services.embercellar.service.impl.BottleServiceImpl
 * @generated
 */
@ProviderType
public class BottleServiceUtil {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify this class directly. Add custom service methods to {@link fr.ippon.services.embercellar.service.impl.BottleServiceImpl} and rerun ServiceBuilder to regenerate this class.
	 */

	/**
	* NOTE FOR DEVELOPERS:
	*
	* Never reference this class directly. Always use {@link fr.ippon.services.embercellar.service.BottleServiceUtil} to access the bottle remote service.
	*/
	public static fr.ippon.services.embercellar.model.Bottle addBottle(
		java.lang.String name, int column, int row, boolean flipped,
		long rackId,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.NoSuchUserException {
		return getService()
				   .addBottle(name, column, row, flipped, rackId, serviceContext);
	}

	public static fr.ippon.services.embercellar.model.Bottle findByBottleId(
		long bottleId) {
		return getService().findByBottleId(bottleId);
	}

	/**
	* Returns the OSGi service identifier.
	*
	* @return the OSGi service identifier
	*/
	public static java.lang.String getOSGiServiceIdentifier() {
		return getService().getOSGiServiceIdentifier();
	}

	public static java.util.List<fr.ippon.services.embercellar.model.Bottle> findAll() {
		return getService().findAll();
	}

	public static java.util.List<fr.ippon.services.embercellar.model.Bottle> findByRackId(
		long rackId) {
		return getService().findByRackId(rackId);
	}

	public static BottleService getService() {
		return _serviceTracker.getService();
	}

	private static ServiceTracker<BottleService, BottleService> _serviceTracker = ServiceTrackerFactory.open(BottleService.class);
}