/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.service;

import aQute.bnd.annotation.ProviderType;

import com.liferay.portal.kernel.service.ServiceWrapper;

/**
 * Provides a wrapper for {@link BottleService}.
 *
 * @author Brian Wing Shun Chan
 * @see BottleService
 * @generated
 */
@ProviderType
public class BottleServiceWrapper implements BottleService,
	ServiceWrapper<BottleService> {
	public BottleServiceWrapper(BottleService bottleService) {
		_bottleService = bottleService;
	}

	/**
	* NOTE FOR DEVELOPERS:
	*
	* Never reference this class directly. Always use {@link fr.ippon.services.embercellar.service.BottleServiceUtil} to access the bottle remote service.
	*/
	@Override
	public fr.ippon.services.embercellar.model.Bottle addBottle(
		java.lang.String name, int column, int row, boolean flipped,
		long rackId,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.NoSuchUserException {
		return _bottleService.addBottle(name, column, row, flipped, rackId,
			serviceContext);
	}

	@Override
	public fr.ippon.services.embercellar.model.Bottle findByBottleId(
		long bottleId) {
		return _bottleService.findByBottleId(bottleId);
	}

	/**
	* Returns the OSGi service identifier.
	*
	* @return the OSGi service identifier
	*/
	@Override
	public java.lang.String getOSGiServiceIdentifier() {
		return _bottleService.getOSGiServiceIdentifier();
	}

	@Override
	public java.util.List<fr.ippon.services.embercellar.model.Bottle> findAll() {
		return _bottleService.findAll();
	}

	@Override
	public java.util.List<fr.ippon.services.embercellar.model.Bottle> findByRackId(
		long rackId) {
		return _bottleService.findByRackId(rackId);
	}

	@Override
	public BottleService getWrappedService() {
		return _bottleService;
	}

	@Override
	public void setWrappedService(BottleService bottleService) {
		_bottleService = bottleService;
	}

	private BottleService _bottleService;
}