/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.service;

import aQute.bnd.annotation.ProviderType;

import com.liferay.portal.kernel.service.ServiceWrapper;

/**
 * Provides a wrapper for {@link RackLocalService}.
 *
 * @author Brian Wing Shun Chan
 * @see RackLocalService
 * @generated
 */
@ProviderType
public class RackLocalServiceWrapper implements RackLocalService,
	ServiceWrapper<RackLocalService> {
	public RackLocalServiceWrapper(RackLocalService rackLocalService) {
		_rackLocalService = rackLocalService;
	}

	@Override
	public com.liferay.portal.kernel.dao.orm.ActionableDynamicQuery getActionableDynamicQuery() {
		return _rackLocalService.getActionableDynamicQuery();
	}

	@Override
	public com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery() {
		return _rackLocalService.dynamicQuery();
	}

	@Override
	public com.liferay.portal.kernel.dao.orm.ExportActionableDynamicQuery getExportActionableDynamicQuery(
		com.liferay.exportimport.kernel.lar.PortletDataContext portletDataContext) {
		return _rackLocalService.getExportActionableDynamicQuery(portletDataContext);
	}

	@Override
	public com.liferay.portal.kernel.dao.orm.IndexableActionableDynamicQuery getIndexableActionableDynamicQuery() {
		return _rackLocalService.getIndexableActionableDynamicQuery();
	}

	/**
	* @throws PortalException
	*/
	@Override
	public com.liferay.portal.kernel.model.PersistedModel deletePersistedModel(
		com.liferay.portal.kernel.model.PersistedModel persistedModel)
		throws com.liferay.portal.kernel.exception.PortalException {
		return _rackLocalService.deletePersistedModel(persistedModel);
	}

	@Override
	public com.liferay.portal.kernel.model.PersistedModel getPersistedModel(
		java.io.Serializable primaryKeyObj)
		throws com.liferay.portal.kernel.exception.PortalException {
		return _rackLocalService.getPersistedModel(primaryKeyObj);
	}

	/**
	* Adds the rack to the database. Also notifies the appropriate model listeners.
	*
	* @param rack the rack
	* @return the rack that was added
	*/
	@Override
	public fr.ippon.services.embercellar.model.Rack addRack(
		fr.ippon.services.embercellar.model.Rack rack) {
		return _rackLocalService.addRack(rack);
	}

	@Override
	public fr.ippon.services.embercellar.model.Rack addRack(long userId,
		long groupId, java.lang.String name, int nbColumns, int nbRows,
		java.lang.String pathImg,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.NoSuchUserException {
		return _rackLocalService.addRack(userId, groupId, name, nbColumns,
			nbRows, pathImg, serviceContext);
	}

	/**
	* Creates a new rack with the primary key. Does not add the rack to the database.
	*
	* @param rackId the primary key for the new rack
	* @return the new rack
	*/
	@Override
	public fr.ippon.services.embercellar.model.Rack createRack(long rackId) {
		return _rackLocalService.createRack(rackId);
	}

	/**
	* Deletes the rack from the database. Also notifies the appropriate model listeners.
	*
	* @param rack the rack
	* @return the rack that was removed
	*/
	@Override
	public fr.ippon.services.embercellar.model.Rack deleteRack(
		fr.ippon.services.embercellar.model.Rack rack) {
		return _rackLocalService.deleteRack(rack);
	}

	/**
	* Deletes the rack with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param rackId the primary key of the rack
	* @return the rack that was removed
	* @throws PortalException if a rack with the primary key could not be found
	*/
	@Override
	public fr.ippon.services.embercellar.model.Rack deleteRack(long rackId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return _rackLocalService.deleteRack(rackId);
	}

	@Override
	public fr.ippon.services.embercellar.model.Rack fetchRack(long rackId) {
		return _rackLocalService.fetchRack(rackId);
	}

	/**
	* Returns the rack matching the UUID and group.
	*
	* @param uuid the rack's UUID
	* @param groupId the primary key of the group
	* @return the matching rack, or <code>null</code> if a matching rack could not be found
	*/
	@Override
	public fr.ippon.services.embercellar.model.Rack fetchRackByUuidAndGroupId(
		java.lang.String uuid, long groupId) {
		return _rackLocalService.fetchRackByUuidAndGroupId(uuid, groupId);
	}

	@Override
	public fr.ippon.services.embercellar.model.Rack findByRackId(long rackId) {
		return _rackLocalService.findByRackId(rackId);
	}

	/**
	* Returns the rack with the primary key.
	*
	* @param rackId the primary key of the rack
	* @return the rack
	* @throws PortalException if a rack with the primary key could not be found
	*/
	@Override
	public fr.ippon.services.embercellar.model.Rack getRack(long rackId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return _rackLocalService.getRack(rackId);
	}

	/**
	* Returns the rack matching the UUID and group.
	*
	* @param uuid the rack's UUID
	* @param groupId the primary key of the group
	* @return the matching rack
	* @throws PortalException if a matching rack could not be found
	*/
	@Override
	public fr.ippon.services.embercellar.model.Rack getRackByUuidAndGroupId(
		java.lang.String uuid, long groupId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return _rackLocalService.getRackByUuidAndGroupId(uuid, groupId);
	}

	/**
	* Updates the rack in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	*
	* @param rack the rack
	* @return the rack that was updated
	*/
	@Override
	public fr.ippon.services.embercellar.model.Rack updateRack(
		fr.ippon.services.embercellar.model.Rack rack) {
		return _rackLocalService.updateRack(rack);
	}

	/**
	* Returns the number of racks.
	*
	* @return the number of racks
	*/
	@Override
	public int getRacksCount() {
		return _rackLocalService.getRacksCount();
	}

	/**
	* Returns the OSGi service identifier.
	*
	* @return the OSGi service identifier
	*/
	@Override
	public java.lang.String getOSGiServiceIdentifier() {
		return _rackLocalService.getOSGiServiceIdentifier();
	}

	/**
	* Performs a dynamic query on the database and returns the matching rows.
	*
	* @param dynamicQuery the dynamic query
	* @return the matching rows
	*/
	@Override
	public <T> java.util.List<T> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery) {
		return _rackLocalService.dynamicQuery(dynamicQuery);
	}

	/**
	* Performs a dynamic query on the database and returns a range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link fr.ippon.services.embercellar.model.impl.RackModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @return the range of matching rows
	*/
	@Override
	public <T> java.util.List<T> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) {
		return _rackLocalService.dynamicQuery(dynamicQuery, start, end);
	}

	/**
	* Performs a dynamic query on the database and returns an ordered range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link fr.ippon.services.embercellar.model.impl.RackModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching rows
	*/
	@Override
	public <T> java.util.List<T> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator<T> orderByComparator) {
		return _rackLocalService.dynamicQuery(dynamicQuery, start, end,
			orderByComparator);
	}

	/**
	* NOTE FOR DEVELOPERS:
	* <p/>
	* Never reference this class directly. Always use {@link fr.ippon.services.embercellar.service.RackLocalServiceUtil} to access the rack local service.
	*/
	@Override
	public java.util.List<fr.ippon.services.embercellar.model.Rack> findAll() {
		return _rackLocalService.findAll();
	}

	/**
	* Returns a range of all the racks.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link fr.ippon.services.embercellar.model.impl.RackModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of racks
	* @param end the upper bound of the range of racks (not inclusive)
	* @return the range of racks
	*/
	@Override
	public java.util.List<fr.ippon.services.embercellar.model.Rack> getRacks(
		int start, int end) {
		return _rackLocalService.getRacks(start, end);
	}

	/**
	* Returns all the racks matching the UUID and company.
	*
	* @param uuid the UUID of the racks
	* @param companyId the primary key of the company
	* @return the matching racks, or an empty list if no matches were found
	*/
	@Override
	public java.util.List<fr.ippon.services.embercellar.model.Rack> getRacksByUuidAndCompanyId(
		java.lang.String uuid, long companyId) {
		return _rackLocalService.getRacksByUuidAndCompanyId(uuid, companyId);
	}

	/**
	* Returns a range of racks matching the UUID and company.
	*
	* @param uuid the UUID of the racks
	* @param companyId the primary key of the company
	* @param start the lower bound of the range of racks
	* @param end the upper bound of the range of racks (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the range of matching racks, or an empty list if no matches were found
	*/
	@Override
	public java.util.List<fr.ippon.services.embercellar.model.Rack> getRacksByUuidAndCompanyId(
		java.lang.String uuid, long companyId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator<fr.ippon.services.embercellar.model.Rack> orderByComparator) {
		return _rackLocalService.getRacksByUuidAndCompanyId(uuid, companyId,
			start, end, orderByComparator);
	}

	/**
	* Returns the number of rows matching the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @return the number of rows matching the dynamic query
	*/
	@Override
	public long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery) {
		return _rackLocalService.dynamicQueryCount(dynamicQuery);
	}

	/**
	* Returns the number of rows matching the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @param projection the projection to apply to the query
	* @return the number of rows matching the dynamic query
	*/
	@Override
	public long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery,
		com.liferay.portal.kernel.dao.orm.Projection projection) {
		return _rackLocalService.dynamicQueryCount(dynamicQuery, projection);
	}

	@Override
	public RackLocalService getWrappedService() {
		return _rackLocalService;
	}

	@Override
	public void setWrappedService(RackLocalService rackLocalService) {
		_rackLocalService = rackLocalService;
	}

	private RackLocalService _rackLocalService;
}