/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.service;

import aQute.bnd.annotation.ProviderType;

import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.jsonwebservice.JSONWebService;
import com.liferay.portal.kernel.security.access.control.AccessControlled;
import com.liferay.portal.kernel.service.BaseService;
import com.liferay.portal.kernel.service.ServiceContext;
import com.liferay.portal.kernel.spring.osgi.OSGiBeanProperties;
import com.liferay.portal.kernel.transaction.Isolation;
import com.liferay.portal.kernel.transaction.Transactional;

import fr.ippon.services.embercellar.model.Rack;

import java.util.List;

/**
 * Provides the remote service interface for Rack. Methods of this
 * service are expected to have security checks based on the propagated JAAS
 * credentials because this service can be accessed remotely.
 *
 * @author Brian Wing Shun Chan
 * @see RackServiceUtil
 * @see fr.ippon.services.embercellar.service.base.RackServiceBaseImpl
 * @see fr.ippon.services.embercellar.service.impl.RackServiceImpl
 * @generated
 */
@AccessControlled
@JSONWebService
@OSGiBeanProperties(property =  {
	"json.web.service.context.name=embercellar", "json.web.service.context.path=Rack"}, service = RackService.class)
@ProviderType
@Transactional(isolation = Isolation.PORTAL, rollbackFor =  {
	PortalException.class, SystemException.class})
public interface RackService extends BaseService {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. Always use {@link RackServiceUtil} to access the rack remote service. Add custom service methods to {@link fr.ippon.services.embercellar.service.impl.RackServiceImpl} and rerun ServiceBuilder to automatically copy the method declarations to this interface.
	 */
	public Rack addRack(java.lang.String name, int nbColumns, int nbRows,
		java.lang.String pathImg, ServiceContext serviceContext);

	public Rack findByRackId(long rackId);

	/**
	* Returns the OSGi service identifier.
	*
	* @return the OSGi service identifier
	*/
	public java.lang.String getOSGiServiceIdentifier();

	/**
	* NOTE FOR DEVELOPERS:
	*
	* Never reference this class directly. Always use {@link fr.ippon.services.embercellar.service.RackServiceUtil} to access the rack remote service.
	*/
	public List<Rack> findAll();
}