/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.service;

import aQute.bnd.annotation.ProviderType;

import com.liferay.osgi.util.ServiceTrackerFactory;

import org.osgi.util.tracker.ServiceTracker;

/**
 * Provides the remote service utility for Rack. This utility wraps
 * {@link fr.ippon.services.embercellar.service.impl.RackServiceImpl} and is the
 * primary access point for service operations in application layer code running
 * on a remote server. Methods of this service are expected to have security
 * checks based on the propagated JAAS credentials because this service can be
 * accessed remotely.
 *
 * @author Brian Wing Shun Chan
 * @see RackService
 * @see fr.ippon.services.embercellar.service.base.RackServiceBaseImpl
 * @see fr.ippon.services.embercellar.service.impl.RackServiceImpl
 * @generated
 */
@ProviderType
public class RackServiceUtil {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify this class directly. Add custom service methods to {@link fr.ippon.services.embercellar.service.impl.RackServiceImpl} and rerun ServiceBuilder to regenerate this class.
	 */
	public static fr.ippon.services.embercellar.model.Rack addRack(
		java.lang.String name, int nbColumns, int nbRows,
		java.lang.String pathImg,
		com.liferay.portal.kernel.service.ServiceContext serviceContext) {
		return getService()
				   .addRack(name, nbColumns, nbRows, pathImg, serviceContext);
	}

	public static fr.ippon.services.embercellar.model.Rack findByRackId(
		long rackId) {
		return getService().findByRackId(rackId);
	}

	/**
	* Returns the OSGi service identifier.
	*
	* @return the OSGi service identifier
	*/
	public static java.lang.String getOSGiServiceIdentifier() {
		return getService().getOSGiServiceIdentifier();
	}

	/**
	* NOTE FOR DEVELOPERS:
	*
	* Never reference this class directly. Always use {@link fr.ippon.services.embercellar.service.RackServiceUtil} to access the rack remote service.
	*/
	public static java.util.List<fr.ippon.services.embercellar.model.Rack> findAll() {
		return getService().findAll();
	}

	public static RackService getService() {
		return _serviceTracker.getService();
	}

	private static ServiceTracker<RackService, RackService> _serviceTracker = ServiceTrackerFactory.open(RackService.class);
}