/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.service;

import aQute.bnd.annotation.ProviderType;

import com.liferay.portal.kernel.service.ServiceWrapper;

/**
 * Provides a wrapper for {@link RackService}.
 *
 * @author Brian Wing Shun Chan
 * @see RackService
 * @generated
 */
@ProviderType
public class RackServiceWrapper implements RackService,
	ServiceWrapper<RackService> {
	public RackServiceWrapper(RackService rackService) {
		_rackService = rackService;
	}

	@Override
	public fr.ippon.services.embercellar.model.Rack addRack(
		java.lang.String name, int nbColumns, int nbRows,
		java.lang.String pathImg,
		com.liferay.portal.kernel.service.ServiceContext serviceContext) {
		return _rackService.addRack(name, nbColumns, nbRows, pathImg,
			serviceContext);
	}

	@Override
	public fr.ippon.services.embercellar.model.Rack findByRackId(long rackId) {
		return _rackService.findByRackId(rackId);
	}

	/**
	* Returns the OSGi service identifier.
	*
	* @return the OSGi service identifier
	*/
	@Override
	public java.lang.String getOSGiServiceIdentifier() {
		return _rackService.getOSGiServiceIdentifier();
	}

	/**
	* NOTE FOR DEVELOPERS:
	*
	* Never reference this class directly. Always use {@link fr.ippon.services.embercellar.service.RackServiceUtil} to access the rack remote service.
	*/
	@Override
	public java.util.List<fr.ippon.services.embercellar.model.Rack> findAll() {
		return _rackService.findAll();
	}

	@Override
	public RackService getWrappedService() {
		return _rackService;
	}

	@Override
	public void setWrappedService(RackService rackService) {
		_rackService = rackService;
	}

	private RackService _rackService;
}