/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.service.persistence;

import aQute.bnd.annotation.ProviderType;

import com.liferay.osgi.util.ServiceTrackerFactory;

import com.liferay.portal.kernel.dao.orm.DynamicQuery;
import com.liferay.portal.kernel.service.ServiceContext;
import com.liferay.portal.kernel.util.OrderByComparator;

import fr.ippon.services.embercellar.model.Bottle;

import org.osgi.util.tracker.ServiceTracker;

import java.util.List;

/**
 * The persistence utility for the bottle service. This utility wraps {@link fr.ippon.services.embercellar.service.persistence.impl.BottlePersistenceImpl} and provides direct access to the database for CRUD operations. This utility should only be used by the service layer, as it must operate within a transaction. Never access this utility in a JSP, controller, model, or other front-end class.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see BottlePersistence
 * @see fr.ippon.services.embercellar.service.persistence.impl.BottlePersistenceImpl
 * @generated
 */
@ProviderType
public class BottleUtil {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify this class directly. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
	 */

	/**
	 * @see com.liferay.portal.kernel.service.persistence.BasePersistence#clearCache()
	 */
	public static void clearCache() {
		getPersistence().clearCache();
	}

	/**
	 * @see com.liferay.portal.kernel.service.persistence.BasePersistence#clearCache(com.liferay.portal.kernel.model.BaseModel)
	 */
	public static void clearCache(Bottle bottle) {
		getPersistence().clearCache(bottle);
	}

	/**
	 * @see com.liferay.portal.kernel.service.persistence.BasePersistence#countWithDynamicQuery(DynamicQuery)
	 */
	public static long countWithDynamicQuery(DynamicQuery dynamicQuery) {
		return getPersistence().countWithDynamicQuery(dynamicQuery);
	}

	/**
	 * @see com.liferay.portal.kernel.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery)
	 */
	public static List<Bottle> findWithDynamicQuery(DynamicQuery dynamicQuery) {
		return getPersistence().findWithDynamicQuery(dynamicQuery);
	}

	/**
	 * @see com.liferay.portal.kernel.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery, int, int)
	 */
	public static List<Bottle> findWithDynamicQuery(DynamicQuery dynamicQuery,
		int start, int end) {
		return getPersistence().findWithDynamicQuery(dynamicQuery, start, end);
	}

	/**
	 * @see com.liferay.portal.kernel.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery, int, int, OrderByComparator)
	 */
	public static List<Bottle> findWithDynamicQuery(DynamicQuery dynamicQuery,
		int start, int end, OrderByComparator<Bottle> orderByComparator) {
		return getPersistence()
				   .findWithDynamicQuery(dynamicQuery, start, end,
			orderByComparator);
	}

	/**
	 * @see com.liferay.portal.kernel.service.persistence.BasePersistence#update(com.liferay.portal.kernel.model.BaseModel)
	 */
	public static Bottle update(Bottle bottle) {
		return getPersistence().update(bottle);
	}

	/**
	 * @see com.liferay.portal.kernel.service.persistence.BasePersistence#update(com.liferay.portal.kernel.model.BaseModel, ServiceContext)
	 */
	public static Bottle update(Bottle bottle, ServiceContext serviceContext) {
		return getPersistence().update(bottle, serviceContext);
	}

	/**
	* Returns all the bottles where uuid = &#63;.
	*
	* @param uuid the uuid
	* @return the matching bottles
	*/
	public static List<Bottle> findByUuid(java.lang.String uuid) {
		return getPersistence().findByUuid(uuid);
	}

	/**
	* Returns a range of all the bottles where uuid = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param uuid the uuid
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @return the range of matching bottles
	*/
	public static List<Bottle> findByUuid(java.lang.String uuid, int start,
		int end) {
		return getPersistence().findByUuid(uuid, start, end);
	}

	/**
	* Returns an ordered range of all the bottles where uuid = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param uuid the uuid
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching bottles
	*/
	public static List<Bottle> findByUuid(java.lang.String uuid, int start,
		int end, OrderByComparator<Bottle> orderByComparator) {
		return getPersistence().findByUuid(uuid, start, end, orderByComparator);
	}

	/**
	* Returns an ordered range of all the bottles where uuid = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param uuid the uuid
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @param retrieveFromCache whether to retrieve from the finder cache
	* @return the ordered range of matching bottles
	*/
	public static List<Bottle> findByUuid(java.lang.String uuid, int start,
		int end, OrderByComparator<Bottle> orderByComparator,
		boolean retrieveFromCache) {
		return getPersistence()
				   .findByUuid(uuid, start, end, orderByComparator,
			retrieveFromCache);
	}

	/**
	* Returns the first bottle in the ordered set where uuid = &#63;.
	*
	* @param uuid the uuid
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching bottle
	* @throws NoSuchBottleException if a matching bottle could not be found
	*/
	public static Bottle findByUuid_First(java.lang.String uuid,
		OrderByComparator<Bottle> orderByComparator)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence().findByUuid_First(uuid, orderByComparator);
	}

	/**
	* Returns the first bottle in the ordered set where uuid = &#63;.
	*
	* @param uuid the uuid
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching bottle, or <code>null</code> if a matching bottle could not be found
	*/
	public static Bottle fetchByUuid_First(java.lang.String uuid,
		OrderByComparator<Bottle> orderByComparator) {
		return getPersistence().fetchByUuid_First(uuid, orderByComparator);
	}

	/**
	* Returns the last bottle in the ordered set where uuid = &#63;.
	*
	* @param uuid the uuid
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching bottle
	* @throws NoSuchBottleException if a matching bottle could not be found
	*/
	public static Bottle findByUuid_Last(java.lang.String uuid,
		OrderByComparator<Bottle> orderByComparator)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence().findByUuid_Last(uuid, orderByComparator);
	}

	/**
	* Returns the last bottle in the ordered set where uuid = &#63;.
	*
	* @param uuid the uuid
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching bottle, or <code>null</code> if a matching bottle could not be found
	*/
	public static Bottle fetchByUuid_Last(java.lang.String uuid,
		OrderByComparator<Bottle> orderByComparator) {
		return getPersistence().fetchByUuid_Last(uuid, orderByComparator);
	}

	/**
	* Returns the bottles before and after the current bottle in the ordered set where uuid = &#63;.
	*
	* @param bottleId the primary key of the current bottle
	* @param uuid the uuid
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next bottle
	* @throws NoSuchBottleException if a bottle with the primary key could not be found
	*/
	public static Bottle[] findByUuid_PrevAndNext(long bottleId,
		java.lang.String uuid, OrderByComparator<Bottle> orderByComparator)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence()
				   .findByUuid_PrevAndNext(bottleId, uuid, orderByComparator);
	}

	/**
	* Removes all the bottles where uuid = &#63; from the database.
	*
	* @param uuid the uuid
	*/
	public static void removeByUuid(java.lang.String uuid) {
		getPersistence().removeByUuid(uuid);
	}

	/**
	* Returns the number of bottles where uuid = &#63;.
	*
	* @param uuid the uuid
	* @return the number of matching bottles
	*/
	public static int countByUuid(java.lang.String uuid) {
		return getPersistence().countByUuid(uuid);
	}

	/**
	* Returns the bottle where uuid = &#63; and groupId = &#63; or throws a {@link NoSuchBottleException} if it could not be found.
	*
	* @param uuid the uuid
	* @param groupId the group ID
	* @return the matching bottle
	* @throws NoSuchBottleException if a matching bottle could not be found
	*/
	public static Bottle findByUUID_G(java.lang.String uuid, long groupId)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence().findByUUID_G(uuid, groupId);
	}

	/**
	* Returns the bottle where uuid = &#63; and groupId = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
	*
	* @param uuid the uuid
	* @param groupId the group ID
	* @return the matching bottle, or <code>null</code> if a matching bottle could not be found
	*/
	public static Bottle fetchByUUID_G(java.lang.String uuid, long groupId) {
		return getPersistence().fetchByUUID_G(uuid, groupId);
	}

	/**
	* Returns the bottle where uuid = &#63; and groupId = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
	*
	* @param uuid the uuid
	* @param groupId the group ID
	* @param retrieveFromCache whether to retrieve from the finder cache
	* @return the matching bottle, or <code>null</code> if a matching bottle could not be found
	*/
	public static Bottle fetchByUUID_G(java.lang.String uuid, long groupId,
		boolean retrieveFromCache) {
		return getPersistence().fetchByUUID_G(uuid, groupId, retrieveFromCache);
	}

	/**
	* Removes the bottle where uuid = &#63; and groupId = &#63; from the database.
	*
	* @param uuid the uuid
	* @param groupId the group ID
	* @return the bottle that was removed
	*/
	public static Bottle removeByUUID_G(java.lang.String uuid, long groupId)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence().removeByUUID_G(uuid, groupId);
	}

	/**
	* Returns the number of bottles where uuid = &#63; and groupId = &#63;.
	*
	* @param uuid the uuid
	* @param groupId the group ID
	* @return the number of matching bottles
	*/
	public static int countByUUID_G(java.lang.String uuid, long groupId) {
		return getPersistence().countByUUID_G(uuid, groupId);
	}

	/**
	* Returns all the bottles where uuid = &#63; and companyId = &#63;.
	*
	* @param uuid the uuid
	* @param companyId the company ID
	* @return the matching bottles
	*/
	public static List<Bottle> findByUuid_C(java.lang.String uuid,
		long companyId) {
		return getPersistence().findByUuid_C(uuid, companyId);
	}

	/**
	* Returns a range of all the bottles where uuid = &#63; and companyId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param uuid the uuid
	* @param companyId the company ID
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @return the range of matching bottles
	*/
	public static List<Bottle> findByUuid_C(java.lang.String uuid,
		long companyId, int start, int end) {
		return getPersistence().findByUuid_C(uuid, companyId, start, end);
	}

	/**
	* Returns an ordered range of all the bottles where uuid = &#63; and companyId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param uuid the uuid
	* @param companyId the company ID
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching bottles
	*/
	public static List<Bottle> findByUuid_C(java.lang.String uuid,
		long companyId, int start, int end,
		OrderByComparator<Bottle> orderByComparator) {
		return getPersistence()
				   .findByUuid_C(uuid, companyId, start, end, orderByComparator);
	}

	/**
	* Returns an ordered range of all the bottles where uuid = &#63; and companyId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param uuid the uuid
	* @param companyId the company ID
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @param retrieveFromCache whether to retrieve from the finder cache
	* @return the ordered range of matching bottles
	*/
	public static List<Bottle> findByUuid_C(java.lang.String uuid,
		long companyId, int start, int end,
		OrderByComparator<Bottle> orderByComparator, boolean retrieveFromCache) {
		return getPersistence()
				   .findByUuid_C(uuid, companyId, start, end,
			orderByComparator, retrieveFromCache);
	}

	/**
	* Returns the first bottle in the ordered set where uuid = &#63; and companyId = &#63;.
	*
	* @param uuid the uuid
	* @param companyId the company ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching bottle
	* @throws NoSuchBottleException if a matching bottle could not be found
	*/
	public static Bottle findByUuid_C_First(java.lang.String uuid,
		long companyId, OrderByComparator<Bottle> orderByComparator)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence()
				   .findByUuid_C_First(uuid, companyId, orderByComparator);
	}

	/**
	* Returns the first bottle in the ordered set where uuid = &#63; and companyId = &#63;.
	*
	* @param uuid the uuid
	* @param companyId the company ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching bottle, or <code>null</code> if a matching bottle could not be found
	*/
	public static Bottle fetchByUuid_C_First(java.lang.String uuid,
		long companyId, OrderByComparator<Bottle> orderByComparator) {
		return getPersistence()
				   .fetchByUuid_C_First(uuid, companyId, orderByComparator);
	}

	/**
	* Returns the last bottle in the ordered set where uuid = &#63; and companyId = &#63;.
	*
	* @param uuid the uuid
	* @param companyId the company ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching bottle
	* @throws NoSuchBottleException if a matching bottle could not be found
	*/
	public static Bottle findByUuid_C_Last(java.lang.String uuid,
		long companyId, OrderByComparator<Bottle> orderByComparator)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence()
				   .findByUuid_C_Last(uuid, companyId, orderByComparator);
	}

	/**
	* Returns the last bottle in the ordered set where uuid = &#63; and companyId = &#63;.
	*
	* @param uuid the uuid
	* @param companyId the company ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching bottle, or <code>null</code> if a matching bottle could not be found
	*/
	public static Bottle fetchByUuid_C_Last(java.lang.String uuid,
		long companyId, OrderByComparator<Bottle> orderByComparator) {
		return getPersistence()
				   .fetchByUuid_C_Last(uuid, companyId, orderByComparator);
	}

	/**
	* Returns the bottles before and after the current bottle in the ordered set where uuid = &#63; and companyId = &#63;.
	*
	* @param bottleId the primary key of the current bottle
	* @param uuid the uuid
	* @param companyId the company ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next bottle
	* @throws NoSuchBottleException if a bottle with the primary key could not be found
	*/
	public static Bottle[] findByUuid_C_PrevAndNext(long bottleId,
		java.lang.String uuid, long companyId,
		OrderByComparator<Bottle> orderByComparator)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence()
				   .findByUuid_C_PrevAndNext(bottleId, uuid, companyId,
			orderByComparator);
	}

	/**
	* Removes all the bottles where uuid = &#63; and companyId = &#63; from the database.
	*
	* @param uuid the uuid
	* @param companyId the company ID
	*/
	public static void removeByUuid_C(java.lang.String uuid, long companyId) {
		getPersistence().removeByUuid_C(uuid, companyId);
	}

	/**
	* Returns the number of bottles where uuid = &#63; and companyId = &#63;.
	*
	* @param uuid the uuid
	* @param companyId the company ID
	* @return the number of matching bottles
	*/
	public static int countByUuid_C(java.lang.String uuid, long companyId) {
		return getPersistence().countByUuid_C(uuid, companyId);
	}

	/**
	* Returns all the bottles where name = &#63;.
	*
	* @param name the name
	* @return the matching bottles
	*/
	public static List<Bottle> findByName(java.lang.String name) {
		return getPersistence().findByName(name);
	}

	/**
	* Returns a range of all the bottles where name = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param name the name
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @return the range of matching bottles
	*/
	public static List<Bottle> findByName(java.lang.String name, int start,
		int end) {
		return getPersistence().findByName(name, start, end);
	}

	/**
	* Returns an ordered range of all the bottles where name = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param name the name
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching bottles
	*/
	public static List<Bottle> findByName(java.lang.String name, int start,
		int end, OrderByComparator<Bottle> orderByComparator) {
		return getPersistence().findByName(name, start, end, orderByComparator);
	}

	/**
	* Returns an ordered range of all the bottles where name = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param name the name
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @param retrieveFromCache whether to retrieve from the finder cache
	* @return the ordered range of matching bottles
	*/
	public static List<Bottle> findByName(java.lang.String name, int start,
		int end, OrderByComparator<Bottle> orderByComparator,
		boolean retrieveFromCache) {
		return getPersistence()
				   .findByName(name, start, end, orderByComparator,
			retrieveFromCache);
	}

	/**
	* Returns the first bottle in the ordered set where name = &#63;.
	*
	* @param name the name
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching bottle
	* @throws NoSuchBottleException if a matching bottle could not be found
	*/
	public static Bottle findByName_First(java.lang.String name,
		OrderByComparator<Bottle> orderByComparator)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence().findByName_First(name, orderByComparator);
	}

	/**
	* Returns the first bottle in the ordered set where name = &#63;.
	*
	* @param name the name
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching bottle, or <code>null</code> if a matching bottle could not be found
	*/
	public static Bottle fetchByName_First(java.lang.String name,
		OrderByComparator<Bottle> orderByComparator) {
		return getPersistence().fetchByName_First(name, orderByComparator);
	}

	/**
	* Returns the last bottle in the ordered set where name = &#63;.
	*
	* @param name the name
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching bottle
	* @throws NoSuchBottleException if a matching bottle could not be found
	*/
	public static Bottle findByName_Last(java.lang.String name,
		OrderByComparator<Bottle> orderByComparator)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence().findByName_Last(name, orderByComparator);
	}

	/**
	* Returns the last bottle in the ordered set where name = &#63;.
	*
	* @param name the name
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching bottle, or <code>null</code> if a matching bottle could not be found
	*/
	public static Bottle fetchByName_Last(java.lang.String name,
		OrderByComparator<Bottle> orderByComparator) {
		return getPersistence().fetchByName_Last(name, orderByComparator);
	}

	/**
	* Returns the bottles before and after the current bottle in the ordered set where name = &#63;.
	*
	* @param bottleId the primary key of the current bottle
	* @param name the name
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next bottle
	* @throws NoSuchBottleException if a bottle with the primary key could not be found
	*/
	public static Bottle[] findByName_PrevAndNext(long bottleId,
		java.lang.String name, OrderByComparator<Bottle> orderByComparator)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence()
				   .findByName_PrevAndNext(bottleId, name, orderByComparator);
	}

	/**
	* Removes all the bottles where name = &#63; from the database.
	*
	* @param name the name
	*/
	public static void removeByName(java.lang.String name) {
		getPersistence().removeByName(name);
	}

	/**
	* Returns the number of bottles where name = &#63;.
	*
	* @param name the name
	* @return the number of matching bottles
	*/
	public static int countByName(java.lang.String name) {
		return getPersistence().countByName(name);
	}

	/**
	* Returns all the bottles where rackId = &#63;.
	*
	* @param rackId the rack ID
	* @return the matching bottles
	*/
	public static List<Bottle> findByRackId(long rackId) {
		return getPersistence().findByRackId(rackId);
	}

	/**
	* Returns a range of all the bottles where rackId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param rackId the rack ID
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @return the range of matching bottles
	*/
	public static List<Bottle> findByRackId(long rackId, int start, int end) {
		return getPersistence().findByRackId(rackId, start, end);
	}

	/**
	* Returns an ordered range of all the bottles where rackId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param rackId the rack ID
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching bottles
	*/
	public static List<Bottle> findByRackId(long rackId, int start, int end,
		OrderByComparator<Bottle> orderByComparator) {
		return getPersistence()
				   .findByRackId(rackId, start, end, orderByComparator);
	}

	/**
	* Returns an ordered range of all the bottles where rackId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param rackId the rack ID
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @param retrieveFromCache whether to retrieve from the finder cache
	* @return the ordered range of matching bottles
	*/
	public static List<Bottle> findByRackId(long rackId, int start, int end,
		OrderByComparator<Bottle> orderByComparator, boolean retrieveFromCache) {
		return getPersistence()
				   .findByRackId(rackId, start, end, orderByComparator,
			retrieveFromCache);
	}

	/**
	* Returns the first bottle in the ordered set where rackId = &#63;.
	*
	* @param rackId the rack ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching bottle
	* @throws NoSuchBottleException if a matching bottle could not be found
	*/
	public static Bottle findByRackId_First(long rackId,
		OrderByComparator<Bottle> orderByComparator)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence().findByRackId_First(rackId, orderByComparator);
	}

	/**
	* Returns the first bottle in the ordered set where rackId = &#63;.
	*
	* @param rackId the rack ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching bottle, or <code>null</code> if a matching bottle could not be found
	*/
	public static Bottle fetchByRackId_First(long rackId,
		OrderByComparator<Bottle> orderByComparator) {
		return getPersistence().fetchByRackId_First(rackId, orderByComparator);
	}

	/**
	* Returns the last bottle in the ordered set where rackId = &#63;.
	*
	* @param rackId the rack ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching bottle
	* @throws NoSuchBottleException if a matching bottle could not be found
	*/
	public static Bottle findByRackId_Last(long rackId,
		OrderByComparator<Bottle> orderByComparator)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence().findByRackId_Last(rackId, orderByComparator);
	}

	/**
	* Returns the last bottle in the ordered set where rackId = &#63;.
	*
	* @param rackId the rack ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching bottle, or <code>null</code> if a matching bottle could not be found
	*/
	public static Bottle fetchByRackId_Last(long rackId,
		OrderByComparator<Bottle> orderByComparator) {
		return getPersistence().fetchByRackId_Last(rackId, orderByComparator);
	}

	/**
	* Returns the bottles before and after the current bottle in the ordered set where rackId = &#63;.
	*
	* @param bottleId the primary key of the current bottle
	* @param rackId the rack ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next bottle
	* @throws NoSuchBottleException if a bottle with the primary key could not be found
	*/
	public static Bottle[] findByRackId_PrevAndNext(long bottleId, long rackId,
		OrderByComparator<Bottle> orderByComparator)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence()
				   .findByRackId_PrevAndNext(bottleId, rackId, orderByComparator);
	}

	/**
	* Removes all the bottles where rackId = &#63; from the database.
	*
	* @param rackId the rack ID
	*/
	public static void removeByRackId(long rackId) {
		getPersistence().removeByRackId(rackId);
	}

	/**
	* Returns the number of bottles where rackId = &#63;.
	*
	* @param rackId the rack ID
	* @return the number of matching bottles
	*/
	public static int countByRackId(long rackId) {
		return getPersistence().countByRackId(rackId);
	}

	/**
	* Caches the bottle in the entity cache if it is enabled.
	*
	* @param bottle the bottle
	*/
	public static void cacheResult(Bottle bottle) {
		getPersistence().cacheResult(bottle);
	}

	/**
	* Caches the bottles in the entity cache if it is enabled.
	*
	* @param bottles the bottles
	*/
	public static void cacheResult(List<Bottle> bottles) {
		getPersistence().cacheResult(bottles);
	}

	/**
	* Creates a new bottle with the primary key. Does not add the bottle to the database.
	*
	* @param bottleId the primary key for the new bottle
	* @return the new bottle
	*/
	public static Bottle create(long bottleId) {
		return getPersistence().create(bottleId);
	}

	/**
	* Removes the bottle with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param bottleId the primary key of the bottle
	* @return the bottle that was removed
	* @throws NoSuchBottleException if a bottle with the primary key could not be found
	*/
	public static Bottle remove(long bottleId)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence().remove(bottleId);
	}

	public static Bottle updateImpl(Bottle bottle) {
		return getPersistence().updateImpl(bottle);
	}

	/**
	* Returns the bottle with the primary key or throws a {@link NoSuchBottleException} if it could not be found.
	*
	* @param bottleId the primary key of the bottle
	* @return the bottle
	* @throws NoSuchBottleException if a bottle with the primary key could not be found
	*/
	public static Bottle findByPrimaryKey(long bottleId)
		throws fr.ippon.services.embercellar.exception.NoSuchBottleException {
		return getPersistence().findByPrimaryKey(bottleId);
	}

	/**
	* Returns the bottle with the primary key or returns <code>null</code> if it could not be found.
	*
	* @param bottleId the primary key of the bottle
	* @return the bottle, or <code>null</code> if a bottle with the primary key could not be found
	*/
	public static Bottle fetchByPrimaryKey(long bottleId) {
		return getPersistence().fetchByPrimaryKey(bottleId);
	}

	public static java.util.Map<java.io.Serializable, Bottle> fetchByPrimaryKeys(
		java.util.Set<java.io.Serializable> primaryKeys) {
		return getPersistence().fetchByPrimaryKeys(primaryKeys);
	}

	/**
	* Returns all the bottles.
	*
	* @return the bottles
	*/
	public static List<Bottle> findAll() {
		return getPersistence().findAll();
	}

	/**
	* Returns a range of all the bottles.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @return the range of bottles
	*/
	public static List<Bottle> findAll(int start, int end) {
		return getPersistence().findAll(start, end);
	}

	/**
	* Returns an ordered range of all the bottles.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of bottles
	*/
	public static List<Bottle> findAll(int start, int end,
		OrderByComparator<Bottle> orderByComparator) {
		return getPersistence().findAll(start, end, orderByComparator);
	}

	/**
	* Returns an ordered range of all the bottles.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link BottleModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of bottles
	* @param end the upper bound of the range of bottles (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @param retrieveFromCache whether to retrieve from the finder cache
	* @return the ordered range of bottles
	*/
	public static List<Bottle> findAll(int start, int end,
		OrderByComparator<Bottle> orderByComparator, boolean retrieveFromCache) {
		return getPersistence()
				   .findAll(start, end, orderByComparator, retrieveFromCache);
	}

	/**
	* Removes all the bottles from the database.
	*/
	public static void removeAll() {
		getPersistence().removeAll();
	}

	/**
	* Returns the number of bottles.
	*
	* @return the number of bottles
	*/
	public static int countAll() {
		return getPersistence().countAll();
	}

	public static java.util.Set<java.lang.String> getBadColumnNames() {
		return getPersistence().getBadColumnNames();
	}

	public static BottlePersistence getPersistence() {
		return _serviceTracker.getService();
	}

	private static ServiceTracker<BottlePersistence, BottlePersistence> _serviceTracker =
		ServiceTrackerFactory.open(BottlePersistence.class);
}