/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.model.impl;

import aQute.bnd.annotation.ProviderType;

import com.liferay.portal.kernel.model.CacheModel;
import com.liferay.portal.kernel.util.HashUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;

import fr.ippon.services.embercellar.model.Bottle;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

import java.util.Date;

/**
 * The cache model class for representing Bottle in entity cache.
 *
 * @author Brian Wing Shun Chan
 * @see Bottle
 * @generated
 */
@ProviderType
public class BottleCacheModel implements CacheModel<Bottle>, Externalizable {
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof BottleCacheModel)) {
			return false;
		}

		BottleCacheModel bottleCacheModel = (BottleCacheModel)obj;

		if (bottleId == bottleCacheModel.bottleId) {
			return true;
		}

		return false;
	}

	@Override
	public int hashCode() {
		return HashUtil.hash(0, bottleId);
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(29);

		sb.append("{uuid=");
		sb.append(uuid);
		sb.append(", bottleId=");
		sb.append(bottleId);
		sb.append(", groupId=");
		sb.append(groupId);
		sb.append(", companyId=");
		sb.append(companyId);
		sb.append(", userId=");
		sb.append(userId);
		sb.append(", userName=");
		sb.append(userName);
		sb.append(", createDate=");
		sb.append(createDate);
		sb.append(", modifiedDate=");
		sb.append(modifiedDate);
		sb.append(", name=");
		sb.append(name);
		sb.append(", flipped=");
		sb.append(flipped);
		sb.append(", xcolumn=");
		sb.append(xcolumn);
		sb.append(", yrow=");
		sb.append(yrow);
		sb.append(", type=");
		sb.append(type);
		sb.append(", rackId=");
		sb.append(rackId);
		sb.append("}");

		return sb.toString();
	}

	@Override
	public Bottle toEntityModel() {
		BottleImpl bottleImpl = new BottleImpl();

		if (uuid == null) {
			bottleImpl.setUuid(StringPool.BLANK);
		}
		else {
			bottleImpl.setUuid(uuid);
		}

		bottleImpl.setBottleId(bottleId);
		bottleImpl.setGroupId(groupId);
		bottleImpl.setCompanyId(companyId);
		bottleImpl.setUserId(userId);

		if (userName == null) {
			bottleImpl.setUserName(StringPool.BLANK);
		}
		else {
			bottleImpl.setUserName(userName);
		}

		if (createDate == Long.MIN_VALUE) {
			bottleImpl.setCreateDate(null);
		}
		else {
			bottleImpl.setCreateDate(new Date(createDate));
		}

		if (modifiedDate == Long.MIN_VALUE) {
			bottleImpl.setModifiedDate(null);
		}
		else {
			bottleImpl.setModifiedDate(new Date(modifiedDate));
		}

		if (name == null) {
			bottleImpl.setName(StringPool.BLANK);
		}
		else {
			bottleImpl.setName(name);
		}

		bottleImpl.setFlipped(flipped);
		bottleImpl.setXcolumn(xcolumn);
		bottleImpl.setYrow(yrow);

		if (type == null) {
			bottleImpl.setType(StringPool.BLANK);
		}
		else {
			bottleImpl.setType(type);
		}

		bottleImpl.setRackId(rackId);

		bottleImpl.resetOriginalValues();

		return bottleImpl;
	}

	@Override
	public void readExternal(ObjectInput objectInput) throws IOException {
		uuid = objectInput.readUTF();

		bottleId = objectInput.readLong();

		groupId = objectInput.readLong();

		companyId = objectInput.readLong();

		userId = objectInput.readLong();
		userName = objectInput.readUTF();
		createDate = objectInput.readLong();
		modifiedDate = objectInput.readLong();
		name = objectInput.readUTF();

		flipped = objectInput.readBoolean();

		xcolumn = objectInput.readInt();

		yrow = objectInput.readInt();
		type = objectInput.readUTF();

		rackId = objectInput.readLong();
	}

	@Override
	public void writeExternal(ObjectOutput objectOutput)
		throws IOException {
		if (uuid == null) {
			objectOutput.writeUTF(StringPool.BLANK);
		}
		else {
			objectOutput.writeUTF(uuid);
		}

		objectOutput.writeLong(bottleId);

		objectOutput.writeLong(groupId);

		objectOutput.writeLong(companyId);

		objectOutput.writeLong(userId);

		if (userName == null) {
			objectOutput.writeUTF(StringPool.BLANK);
		}
		else {
			objectOutput.writeUTF(userName);
		}

		objectOutput.writeLong(createDate);
		objectOutput.writeLong(modifiedDate);

		if (name == null) {
			objectOutput.writeUTF(StringPool.BLANK);
		}
		else {
			objectOutput.writeUTF(name);
		}

		objectOutput.writeBoolean(flipped);

		objectOutput.writeInt(xcolumn);

		objectOutput.writeInt(yrow);

		if (type == null) {
			objectOutput.writeUTF(StringPool.BLANK);
		}
		else {
			objectOutput.writeUTF(type);
		}

		objectOutput.writeLong(rackId);
	}

	public String uuid;
	public long bottleId;
	public long groupId;
	public long companyId;
	public long userId;
	public String userName;
	public long createDate;
	public long modifiedDate;
	public String name;
	public boolean flipped;
	public int xcolumn;
	public int yrow;
	public String type;
	public long rackId;
}