/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.model.impl;

import aQute.bnd.annotation.ProviderType;

import com.liferay.expando.kernel.model.ExpandoBridge;
import com.liferay.expando.kernel.util.ExpandoBridgeFactoryUtil;

import com.liferay.exportimport.kernel.lar.StagedModelType;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.json.JSON;
import com.liferay.portal.kernel.model.CacheModel;
import com.liferay.portal.kernel.model.User;
import com.liferay.portal.kernel.model.impl.BaseModelImpl;
import com.liferay.portal.kernel.service.ServiceContext;
import com.liferay.portal.kernel.service.UserLocalServiceUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.PortalUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;

import fr.ippon.services.embercellar.model.Bottle;
import fr.ippon.services.embercellar.model.BottleModel;
import fr.ippon.services.embercellar.model.BottleSoap;

import java.io.Serializable;

import java.sql.Types;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * The base model implementation for the Bottle service. Represents a row in the &quot;embercellar_Bottle&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link BottleModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link BottleImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see BottleImpl
 * @see Bottle
 * @see BottleModel
 * @generated
 */
@JSON(strict = true)
@ProviderType
public class BottleModelImpl extends BaseModelImpl<Bottle>
	implements BottleModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a bottle model instance should use the {@link Bottle} interface instead.
	 */
	public static final String TABLE_NAME = "embercellar_Bottle";
	public static final Object[][] TABLE_COLUMNS = {
			{ "uuid_", Types.VARCHAR },
			{ "bottleId", Types.BIGINT },
			{ "groupId", Types.BIGINT },
			{ "companyId", Types.BIGINT },
			{ "userId", Types.BIGINT },
			{ "userName", Types.VARCHAR },
			{ "createDate", Types.TIMESTAMP },
			{ "modifiedDate", Types.TIMESTAMP },
			{ "name", Types.VARCHAR },
			{ "flipped", Types.BOOLEAN },
			{ "xcolumn", Types.INTEGER },
			{ "yrow", Types.INTEGER },
			{ "type_", Types.VARCHAR },
			{ "rackId", Types.BIGINT }
		};
	public static final Map<String, Integer> TABLE_COLUMNS_MAP = new HashMap<String, Integer>();

	static {
		TABLE_COLUMNS_MAP.put("uuid_", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("bottleId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("groupId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("companyId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("userId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("userName", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("createDate", Types.TIMESTAMP);
		TABLE_COLUMNS_MAP.put("modifiedDate", Types.TIMESTAMP);
		TABLE_COLUMNS_MAP.put("name", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("flipped", Types.BOOLEAN);
		TABLE_COLUMNS_MAP.put("xcolumn", Types.INTEGER);
		TABLE_COLUMNS_MAP.put("yrow", Types.INTEGER);
		TABLE_COLUMNS_MAP.put("type_", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("rackId", Types.BIGINT);
	}

	public static final String TABLE_SQL_CREATE = "create table embercellar_Bottle (uuid_ VARCHAR(75) null,bottleId LONG not null primary key,groupId LONG,companyId LONG,userId LONG,userName VARCHAR(75) null,createDate DATE null,modifiedDate DATE null,name VARCHAR(75) null,flipped BOOLEAN,xcolumn INTEGER,yrow INTEGER,type_ VARCHAR(75) null,rackId LONG)";
	public static final String TABLE_SQL_DROP = "drop table embercellar_Bottle";
	public static final String ORDER_BY_JPQL = " ORDER BY bottle.name ASC";
	public static final String ORDER_BY_SQL = " ORDER BY embercellar_Bottle.name ASC";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(fr.ippon.services.embercellar.service.util.ServiceProps.get(
				"value.object.entity.cache.enabled.fr.ippon.services.embercellar.model.Bottle"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(fr.ippon.services.embercellar.service.util.ServiceProps.get(
				"value.object.finder.cache.enabled.fr.ippon.services.embercellar.model.Bottle"),
			true);
	public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(fr.ippon.services.embercellar.service.util.ServiceProps.get(
				"value.object.column.bitmask.enabled.fr.ippon.services.embercellar.model.Bottle"),
			true);
	public static final long COMPANYID_COLUMN_BITMASK = 1L;
	public static final long GROUPID_COLUMN_BITMASK = 2L;
	public static final long NAME_COLUMN_BITMASK = 4L;
	public static final long RACKID_COLUMN_BITMASK = 8L;
	public static final long UUID_COLUMN_BITMASK = 16L;

	/**
	 * Converts the soap model instance into a normal model instance.
	 *
	 * @param soapModel the soap model instance to convert
	 * @return the normal model instance
	 */
	public static Bottle toModel(BottleSoap soapModel) {
		if (soapModel == null) {
			return null;
		}

		Bottle model = new BottleImpl();

		model.setUuid(soapModel.getUuid());
		model.setBottleId(soapModel.getBottleId());
		model.setGroupId(soapModel.getGroupId());
		model.setCompanyId(soapModel.getCompanyId());
		model.setUserId(soapModel.getUserId());
		model.setUserName(soapModel.getUserName());
		model.setCreateDate(soapModel.getCreateDate());
		model.setModifiedDate(soapModel.getModifiedDate());
		model.setName(soapModel.getName());
		model.setFlipped(soapModel.getFlipped());
		model.setXcolumn(soapModel.getXcolumn());
		model.setYrow(soapModel.getYrow());
		model.setType(soapModel.getType());
		model.setRackId(soapModel.getRackId());

		return model;
	}

	/**
	 * Converts the soap model instances into normal model instances.
	 *
	 * @param soapModels the soap model instances to convert
	 * @return the normal model instances
	 */
	public static List<Bottle> toModels(BottleSoap[] soapModels) {
		if (soapModels == null) {
			return null;
		}

		List<Bottle> models = new ArrayList<Bottle>(soapModels.length);

		for (BottleSoap soapModel : soapModels) {
			models.add(toModel(soapModel));
		}

		return models;
	}

	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(fr.ippon.services.embercellar.service.util.ServiceProps.get(
				"lock.expiration.time.fr.ippon.services.embercellar.model.Bottle"));

	public BottleModelImpl() {
	}

	@Override
	public long getPrimaryKey() {
		return _bottleId;
	}

	@Override
	public void setPrimaryKey(long primaryKey) {
		setBottleId(primaryKey);
	}

	@Override
	public Serializable getPrimaryKeyObj() {
		return _bottleId;
	}

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	@Override
	public Class<?> getModelClass() {
		return Bottle.class;
	}

	@Override
	public String getModelClassName() {
		return Bottle.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("uuid", getUuid());
		attributes.put("bottleId", getBottleId());
		attributes.put("groupId", getGroupId());
		attributes.put("companyId", getCompanyId());
		attributes.put("userId", getUserId());
		attributes.put("userName", getUserName());
		attributes.put("createDate", getCreateDate());
		attributes.put("modifiedDate", getModifiedDate());
		attributes.put("name", getName());
		attributes.put("flipped", getFlipped());
		attributes.put("xcolumn", getXcolumn());
		attributes.put("yrow", getYrow());
		attributes.put("type", getType());
		attributes.put("rackId", getRackId());

		attributes.put("entityCacheEnabled", isEntityCacheEnabled());
		attributes.put("finderCacheEnabled", isFinderCacheEnabled());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		String uuid = (String)attributes.get("uuid");

		if (uuid != null) {
			setUuid(uuid);
		}

		Long bottleId = (Long)attributes.get("bottleId");

		if (bottleId != null) {
			setBottleId(bottleId);
		}

		Long groupId = (Long)attributes.get("groupId");

		if (groupId != null) {
			setGroupId(groupId);
		}

		Long companyId = (Long)attributes.get("companyId");

		if (companyId != null) {
			setCompanyId(companyId);
		}

		Long userId = (Long)attributes.get("userId");

		if (userId != null) {
			setUserId(userId);
		}

		String userName = (String)attributes.get("userName");

		if (userName != null) {
			setUserName(userName);
		}

		Date createDate = (Date)attributes.get("createDate");

		if (createDate != null) {
			setCreateDate(createDate);
		}

		Date modifiedDate = (Date)attributes.get("modifiedDate");

		if (modifiedDate != null) {
			setModifiedDate(modifiedDate);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		Boolean flipped = (Boolean)attributes.get("flipped");

		if (flipped != null) {
			setFlipped(flipped);
		}

		Integer xcolumn = (Integer)attributes.get("xcolumn");

		if (xcolumn != null) {
			setXcolumn(xcolumn);
		}

		Integer yrow = (Integer)attributes.get("yrow");

		if (yrow != null) {
			setYrow(yrow);
		}

		String type = (String)attributes.get("type");

		if (type != null) {
			setType(type);
		}

		Long rackId = (Long)attributes.get("rackId");

		if (rackId != null) {
			setRackId(rackId);
		}
	}

	@JSON
	@Override
	public String getUuid() {
		if (_uuid == null) {
			return StringPool.BLANK;
		}
		else {
			return _uuid;
		}
	}

	@Override
	public void setUuid(String uuid) {
		if (_originalUuid == null) {
			_originalUuid = _uuid;
		}

		_uuid = uuid;
	}

	public String getOriginalUuid() {
		return GetterUtil.getString(_originalUuid);
	}

	@JSON
	@Override
	public long getBottleId() {
		return _bottleId;
	}

	@Override
	public void setBottleId(long bottleId) {
		_bottleId = bottleId;
	}

	@JSON
	@Override
	public long getGroupId() {
		return _groupId;
	}

	@Override
	public void setGroupId(long groupId) {
		_columnBitmask |= GROUPID_COLUMN_BITMASK;

		if (!_setOriginalGroupId) {
			_setOriginalGroupId = true;

			_originalGroupId = _groupId;
		}

		_groupId = groupId;
	}

	public long getOriginalGroupId() {
		return _originalGroupId;
	}

	@JSON
	@Override
	public long getCompanyId() {
		return _companyId;
	}

	@Override
	public void setCompanyId(long companyId) {
		_columnBitmask |= COMPANYID_COLUMN_BITMASK;

		if (!_setOriginalCompanyId) {
			_setOriginalCompanyId = true;

			_originalCompanyId = _companyId;
		}

		_companyId = companyId;
	}

	public long getOriginalCompanyId() {
		return _originalCompanyId;
	}

	@JSON
	@Override
	public long getUserId() {
		return _userId;
	}

	@Override
	public void setUserId(long userId) {
		_userId = userId;
	}

	@Override
	public String getUserUuid() {
		try {
			User user = UserLocalServiceUtil.getUserById(getUserId());

			return user.getUuid();
		}
		catch (PortalException pe) {
			return StringPool.BLANK;
		}
	}

	@Override
	public void setUserUuid(String userUuid) {
	}

	@JSON
	@Override
	public String getUserName() {
		if (_userName == null) {
			return StringPool.BLANK;
		}
		else {
			return _userName;
		}
	}

	@Override
	public void setUserName(String userName) {
		_userName = userName;
	}

	@JSON
	@Override
	public Date getCreateDate() {
		return _createDate;
	}

	@Override
	public void setCreateDate(Date createDate) {
		_createDate = createDate;
	}

	@JSON
	@Override
	public Date getModifiedDate() {
		return _modifiedDate;
	}

	public boolean hasSetModifiedDate() {
		return _setModifiedDate;
	}

	@Override
	public void setModifiedDate(Date modifiedDate) {
		_setModifiedDate = true;

		_modifiedDate = modifiedDate;
	}

	@JSON
	@Override
	public String getName() {
		if (_name == null) {
			return StringPool.BLANK;
		}
		else {
			return _name;
		}
	}

	@Override
	public void setName(String name) {
		_columnBitmask = -1L;

		if (_originalName == null) {
			_originalName = _name;
		}

		_name = name;
	}

	public String getOriginalName() {
		return GetterUtil.getString(_originalName);
	}

	@JSON
	@Override
	public boolean getFlipped() {
		return _flipped;
	}

	@JSON
	@Override
	public boolean isFlipped() {
		return _flipped;
	}

	@Override
	public void setFlipped(boolean flipped) {
		_flipped = flipped;
	}

	@JSON
	@Override
	public int getXcolumn() {
		return _xcolumn;
	}

	@Override
	public void setXcolumn(int xcolumn) {
		_xcolumn = xcolumn;
	}

	@JSON
	@Override
	public int getYrow() {
		return _yrow;
	}

	@Override
	public void setYrow(int yrow) {
		_yrow = yrow;
	}

	@JSON
	@Override
	public String getType() {
		if (_type == null) {
			return StringPool.BLANK;
		}
		else {
			return _type;
		}
	}

	@Override
	public void setType(String type) {
		_type = type;
	}

	@JSON
	@Override
	public long getRackId() {
		return _rackId;
	}

	@Override
	public void setRackId(long rackId) {
		_columnBitmask |= RACKID_COLUMN_BITMASK;

		if (!_setOriginalRackId) {
			_setOriginalRackId = true;

			_originalRackId = _rackId;
		}

		_rackId = rackId;
	}

	public long getOriginalRackId() {
		return _originalRackId;
	}

	@Override
	public StagedModelType getStagedModelType() {
		return new StagedModelType(PortalUtil.getClassNameId(
				Bottle.class.getName()));
	}

	public long getColumnBitmask() {
		return _columnBitmask;
	}

	@Override
	public ExpandoBridge getExpandoBridge() {
		return ExpandoBridgeFactoryUtil.getExpandoBridge(getCompanyId(),
			Bottle.class.getName(), getPrimaryKey());
	}

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		ExpandoBridge expandoBridge = getExpandoBridge();

		expandoBridge.setAttributes(serviceContext);
	}

	@Override
	public Bottle toEscapedModel() {
		if (_escapedModel == null) {
			_escapedModel = (Bottle)ProxyUtil.newProxyInstance(_classLoader,
					_escapedModelInterfaces, new AutoEscapeBeanHandler(this));
		}

		return _escapedModel;
	}

	@Override
	public Object clone() {
		BottleImpl bottleImpl = new BottleImpl();

		bottleImpl.setUuid(getUuid());
		bottleImpl.setBottleId(getBottleId());
		bottleImpl.setGroupId(getGroupId());
		bottleImpl.setCompanyId(getCompanyId());
		bottleImpl.setUserId(getUserId());
		bottleImpl.setUserName(getUserName());
		bottleImpl.setCreateDate(getCreateDate());
		bottleImpl.setModifiedDate(getModifiedDate());
		bottleImpl.setName(getName());
		bottleImpl.setFlipped(getFlipped());
		bottleImpl.setXcolumn(getXcolumn());
		bottleImpl.setYrow(getYrow());
		bottleImpl.setType(getType());
		bottleImpl.setRackId(getRackId());

		bottleImpl.resetOriginalValues();

		return bottleImpl;
	}

	@Override
	public int compareTo(Bottle bottle) {
		int value = 0;

		value = getName().compareTo(bottle.getName());

		if (value != 0) {
			return value;
		}

		return 0;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof Bottle)) {
			return false;
		}

		Bottle bottle = (Bottle)obj;

		long primaryKey = bottle.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public boolean isEntityCacheEnabled() {
		return ENTITY_CACHE_ENABLED;
	}

	@Override
	public boolean isFinderCacheEnabled() {
		return FINDER_CACHE_ENABLED;
	}

	@Override
	public void resetOriginalValues() {
		BottleModelImpl bottleModelImpl = this;

		bottleModelImpl._originalUuid = bottleModelImpl._uuid;

		bottleModelImpl._originalGroupId = bottleModelImpl._groupId;

		bottleModelImpl._setOriginalGroupId = false;

		bottleModelImpl._originalCompanyId = bottleModelImpl._companyId;

		bottleModelImpl._setOriginalCompanyId = false;

		bottleModelImpl._setModifiedDate = false;

		bottleModelImpl._originalName = bottleModelImpl._name;

		bottleModelImpl._originalRackId = bottleModelImpl._rackId;

		bottleModelImpl._setOriginalRackId = false;

		bottleModelImpl._columnBitmask = 0;
	}

	@Override
	public CacheModel<Bottle> toCacheModel() {
		BottleCacheModel bottleCacheModel = new BottleCacheModel();

		bottleCacheModel.uuid = getUuid();

		String uuid = bottleCacheModel.uuid;

		if ((uuid != null) && (uuid.length() == 0)) {
			bottleCacheModel.uuid = null;
		}

		bottleCacheModel.bottleId = getBottleId();

		bottleCacheModel.groupId = getGroupId();

		bottleCacheModel.companyId = getCompanyId();

		bottleCacheModel.userId = getUserId();

		bottleCacheModel.userName = getUserName();

		String userName = bottleCacheModel.userName;

		if ((userName != null) && (userName.length() == 0)) {
			bottleCacheModel.userName = null;
		}

		Date createDate = getCreateDate();

		if (createDate != null) {
			bottleCacheModel.createDate = createDate.getTime();
		}
		else {
			bottleCacheModel.createDate = Long.MIN_VALUE;
		}

		Date modifiedDate = getModifiedDate();

		if (modifiedDate != null) {
			bottleCacheModel.modifiedDate = modifiedDate.getTime();
		}
		else {
			bottleCacheModel.modifiedDate = Long.MIN_VALUE;
		}

		bottleCacheModel.name = getName();

		String name = bottleCacheModel.name;

		if ((name != null) && (name.length() == 0)) {
			bottleCacheModel.name = null;
		}

		bottleCacheModel.flipped = getFlipped();

		bottleCacheModel.xcolumn = getXcolumn();

		bottleCacheModel.yrow = getYrow();

		bottleCacheModel.type = getType();

		String type = bottleCacheModel.type;

		if ((type != null) && (type.length() == 0)) {
			bottleCacheModel.type = null;
		}

		bottleCacheModel.rackId = getRackId();

		return bottleCacheModel;
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(29);

		sb.append("{uuid=");
		sb.append(getUuid());
		sb.append(", bottleId=");
		sb.append(getBottleId());
		sb.append(", groupId=");
		sb.append(getGroupId());
		sb.append(", companyId=");
		sb.append(getCompanyId());
		sb.append(", userId=");
		sb.append(getUserId());
		sb.append(", userName=");
		sb.append(getUserName());
		sb.append(", createDate=");
		sb.append(getCreateDate());
		sb.append(", modifiedDate=");
		sb.append(getModifiedDate());
		sb.append(", name=");
		sb.append(getName());
		sb.append(", flipped=");
		sb.append(getFlipped());
		sb.append(", xcolumn=");
		sb.append(getXcolumn());
		sb.append(", yrow=");
		sb.append(getYrow());
		sb.append(", type=");
		sb.append(getType());
		sb.append(", rackId=");
		sb.append(getRackId());
		sb.append("}");

		return sb.toString();
	}

	@Override
	public String toXmlString() {
		StringBundler sb = new StringBundler(46);

		sb.append("<model><model-name>");
		sb.append("fr.ippon.services.embercellar.model.Bottle");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>uuid</column-name><column-value><![CDATA[");
		sb.append(getUuid());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>bottleId</column-name><column-value><![CDATA[");
		sb.append(getBottleId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>groupId</column-name><column-value><![CDATA[");
		sb.append(getGroupId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>companyId</column-name><column-value><![CDATA[");
		sb.append(getCompanyId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userId</column-name><column-value><![CDATA[");
		sb.append(getUserId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userName</column-name><column-value><![CDATA[");
		sb.append(getUserName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>createDate</column-name><column-value><![CDATA[");
		sb.append(getCreateDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
		sb.append(getModifiedDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>name</column-name><column-value><![CDATA[");
		sb.append(getName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>flipped</column-name><column-value><![CDATA[");
		sb.append(getFlipped());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>xcolumn</column-name><column-value><![CDATA[");
		sb.append(getXcolumn());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>yrow</column-name><column-value><![CDATA[");
		sb.append(getYrow());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>type</column-name><column-value><![CDATA[");
		sb.append(getType());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>rackId</column-name><column-value><![CDATA[");
		sb.append(getRackId());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private static final ClassLoader _classLoader = Bottle.class.getClassLoader();
	private static final Class<?>[] _escapedModelInterfaces = new Class[] {
			Bottle.class
		};
	private String _uuid;
	private String _originalUuid;
	private long _bottleId;
	private long _groupId;
	private long _originalGroupId;
	private boolean _setOriginalGroupId;
	private long _companyId;
	private long _originalCompanyId;
	private boolean _setOriginalCompanyId;
	private long _userId;
	private String _userName;
	private Date _createDate;
	private Date _modifiedDate;
	private boolean _setModifiedDate;
	private String _name;
	private String _originalName;
	private boolean _flipped;
	private int _xcolumn;
	private int _yrow;
	private String _type;
	private long _rackId;
	private long _originalRackId;
	private boolean _setOriginalRackId;
	private long _columnBitmask;
	private Bottle _escapedModel;
}