/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.model.impl;

import aQute.bnd.annotation.ProviderType;

import com.liferay.expando.kernel.model.ExpandoBridge;
import com.liferay.expando.kernel.util.ExpandoBridgeFactoryUtil;

import com.liferay.exportimport.kernel.lar.StagedModelType;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.json.JSON;
import com.liferay.portal.kernel.model.CacheModel;
import com.liferay.portal.kernel.model.User;
import com.liferay.portal.kernel.model.impl.BaseModelImpl;
import com.liferay.portal.kernel.service.ServiceContext;
import com.liferay.portal.kernel.service.UserLocalServiceUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.PortalUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;

import fr.ippon.services.embercellar.model.Rack;
import fr.ippon.services.embercellar.model.RackModel;
import fr.ippon.services.embercellar.model.RackSoap;

import java.io.Serializable;

import java.sql.Types;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * The base model implementation for the Rack service. Represents a row in the &quot;embercellar_Rack&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link RackModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link RackImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see RackImpl
 * @see Rack
 * @see RackModel
 * @generated
 */
@JSON(strict = true)
@ProviderType
public class RackModelImpl extends BaseModelImpl<Rack> implements RackModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a rack model instance should use the {@link Rack} interface instead.
	 */
	public static final String TABLE_NAME = "embercellar_Rack";
	public static final Object[][] TABLE_COLUMNS = {
			{ "uuid_", Types.VARCHAR },
			{ "rackId", Types.BIGINT },
			{ "groupId", Types.BIGINT },
			{ "companyId", Types.BIGINT },
			{ "userId", Types.BIGINT },
			{ "userName", Types.VARCHAR },
			{ "createDate", Types.TIMESTAMP },
			{ "modifiedDate", Types.TIMESTAMP },
			{ "type_", Types.VARCHAR },
			{ "name", Types.VARCHAR },
			{ "nbColumns", Types.INTEGER },
			{ "nbRows", Types.INTEGER },
			{ "image", Types.VARCHAR },
			{ "bottlesId", Types.VARCHAR }
		};
	public static final Map<String, Integer> TABLE_COLUMNS_MAP = new HashMap<String, Integer>();

	static {
		TABLE_COLUMNS_MAP.put("uuid_", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("rackId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("groupId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("companyId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("userId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("userName", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("createDate", Types.TIMESTAMP);
		TABLE_COLUMNS_MAP.put("modifiedDate", Types.TIMESTAMP);
		TABLE_COLUMNS_MAP.put("type_", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("name", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("nbColumns", Types.INTEGER);
		TABLE_COLUMNS_MAP.put("nbRows", Types.INTEGER);
		TABLE_COLUMNS_MAP.put("image", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("bottlesId", Types.VARCHAR);
	}

	public static final String TABLE_SQL_CREATE = "create table embercellar_Rack (uuid_ VARCHAR(75) null,rackId LONG not null primary key,groupId LONG,companyId LONG,userId LONG,userName VARCHAR(75) null,createDate DATE null,modifiedDate DATE null,type_ VARCHAR(75) null,name VARCHAR(75) null,nbColumns INTEGER,nbRows INTEGER,image VARCHAR(75) null,bottlesId VARCHAR(75) null)";
	public static final String TABLE_SQL_DROP = "drop table embercellar_Rack";
	public static final String ORDER_BY_JPQL = " ORDER BY rack.name ASC";
	public static final String ORDER_BY_SQL = " ORDER BY embercellar_Rack.name ASC";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(fr.ippon.services.embercellar.service.util.ServiceProps.get(
				"value.object.entity.cache.enabled.fr.ippon.services.embercellar.model.Rack"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(fr.ippon.services.embercellar.service.util.ServiceProps.get(
				"value.object.finder.cache.enabled.fr.ippon.services.embercellar.model.Rack"),
			true);
	public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(fr.ippon.services.embercellar.service.util.ServiceProps.get(
				"value.object.column.bitmask.enabled.fr.ippon.services.embercellar.model.Rack"),
			true);
	public static final long COMPANYID_COLUMN_BITMASK = 1L;
	public static final long GROUPID_COLUMN_BITMASK = 2L;
	public static final long NAME_COLUMN_BITMASK = 4L;
	public static final long UUID_COLUMN_BITMASK = 8L;

	/**
	 * Converts the soap model instance into a normal model instance.
	 *
	 * @param soapModel the soap model instance to convert
	 * @return the normal model instance
	 */
	public static Rack toModel(RackSoap soapModel) {
		if (soapModel == null) {
			return null;
		}

		Rack model = new RackImpl();

		model.setUuid(soapModel.getUuid());
		model.setRackId(soapModel.getRackId());
		model.setGroupId(soapModel.getGroupId());
		model.setCompanyId(soapModel.getCompanyId());
		model.setUserId(soapModel.getUserId());
		model.setUserName(soapModel.getUserName());
		model.setCreateDate(soapModel.getCreateDate());
		model.setModifiedDate(soapModel.getModifiedDate());
		model.setType(soapModel.getType());
		model.setName(soapModel.getName());
		model.setNbColumns(soapModel.getNbColumns());
		model.setNbRows(soapModel.getNbRows());
		model.setImage(soapModel.getImage());
		model.setBottlesId(soapModel.getBottlesId());

		return model;
	}

	/**
	 * Converts the soap model instances into normal model instances.
	 *
	 * @param soapModels the soap model instances to convert
	 * @return the normal model instances
	 */
	public static List<Rack> toModels(RackSoap[] soapModels) {
		if (soapModels == null) {
			return null;
		}

		List<Rack> models = new ArrayList<Rack>(soapModels.length);

		for (RackSoap soapModel : soapModels) {
			models.add(toModel(soapModel));
		}

		return models;
	}

	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(fr.ippon.services.embercellar.service.util.ServiceProps.get(
				"lock.expiration.time.fr.ippon.services.embercellar.model.Rack"));

	public RackModelImpl() {
	}

	@Override
	public long getPrimaryKey() {
		return _rackId;
	}

	@Override
	public void setPrimaryKey(long primaryKey) {
		setRackId(primaryKey);
	}

	@Override
	public Serializable getPrimaryKeyObj() {
		return _rackId;
	}

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	@Override
	public Class<?> getModelClass() {
		return Rack.class;
	}

	@Override
	public String getModelClassName() {
		return Rack.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("uuid", getUuid());
		attributes.put("rackId", getRackId());
		attributes.put("groupId", getGroupId());
		attributes.put("companyId", getCompanyId());
		attributes.put("userId", getUserId());
		attributes.put("userName", getUserName());
		attributes.put("createDate", getCreateDate());
		attributes.put("modifiedDate", getModifiedDate());
		attributes.put("type", getType());
		attributes.put("name", getName());
		attributes.put("nbColumns", getNbColumns());
		attributes.put("nbRows", getNbRows());
		attributes.put("image", getImage());
		attributes.put("bottlesId", getBottlesId());

		attributes.put("entityCacheEnabled", isEntityCacheEnabled());
		attributes.put("finderCacheEnabled", isFinderCacheEnabled());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		String uuid = (String)attributes.get("uuid");

		if (uuid != null) {
			setUuid(uuid);
		}

		Long rackId = (Long)attributes.get("rackId");

		if (rackId != null) {
			setRackId(rackId);
		}

		Long groupId = (Long)attributes.get("groupId");

		if (groupId != null) {
			setGroupId(groupId);
		}

		Long companyId = (Long)attributes.get("companyId");

		if (companyId != null) {
			setCompanyId(companyId);
		}

		Long userId = (Long)attributes.get("userId");

		if (userId != null) {
			setUserId(userId);
		}

		String userName = (String)attributes.get("userName");

		if (userName != null) {
			setUserName(userName);
		}

		Date createDate = (Date)attributes.get("createDate");

		if (createDate != null) {
			setCreateDate(createDate);
		}

		Date modifiedDate = (Date)attributes.get("modifiedDate");

		if (modifiedDate != null) {
			setModifiedDate(modifiedDate);
		}

		String type = (String)attributes.get("type");

		if (type != null) {
			setType(type);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		Integer nbColumns = (Integer)attributes.get("nbColumns");

		if (nbColumns != null) {
			setNbColumns(nbColumns);
		}

		Integer nbRows = (Integer)attributes.get("nbRows");

		if (nbRows != null) {
			setNbRows(nbRows);
		}

		String image = (String)attributes.get("image");

		if (image != null) {
			setImage(image);
		}

		String bottlesId = (String)attributes.get("bottlesId");

		if (bottlesId != null) {
			setBottlesId(bottlesId);
		}
	}

	@JSON
	@Override
	public String getUuid() {
		if (_uuid == null) {
			return StringPool.BLANK;
		}
		else {
			return _uuid;
		}
	}

	@Override
	public void setUuid(String uuid) {
		if (_originalUuid == null) {
			_originalUuid = _uuid;
		}

		_uuid = uuid;
	}

	public String getOriginalUuid() {
		return GetterUtil.getString(_originalUuid);
	}

	@JSON
	@Override
	public long getRackId() {
		return _rackId;
	}

	@Override
	public void setRackId(long rackId) {
		_rackId = rackId;
	}

	@JSON
	@Override
	public long getGroupId() {
		return _groupId;
	}

	@Override
	public void setGroupId(long groupId) {
		_columnBitmask |= GROUPID_COLUMN_BITMASK;

		if (!_setOriginalGroupId) {
			_setOriginalGroupId = true;

			_originalGroupId = _groupId;
		}

		_groupId = groupId;
	}

	public long getOriginalGroupId() {
		return _originalGroupId;
	}

	@JSON
	@Override
	public long getCompanyId() {
		return _companyId;
	}

	@Override
	public void setCompanyId(long companyId) {
		_columnBitmask |= COMPANYID_COLUMN_BITMASK;

		if (!_setOriginalCompanyId) {
			_setOriginalCompanyId = true;

			_originalCompanyId = _companyId;
		}

		_companyId = companyId;
	}

	public long getOriginalCompanyId() {
		return _originalCompanyId;
	}

	@JSON
	@Override
	public long getUserId() {
		return _userId;
	}

	@Override
	public void setUserId(long userId) {
		_userId = userId;
	}

	@Override
	public String getUserUuid() {
		try {
			User user = UserLocalServiceUtil.getUserById(getUserId());

			return user.getUuid();
		}
		catch (PortalException pe) {
			return StringPool.BLANK;
		}
	}

	@Override
	public void setUserUuid(String userUuid) {
	}

	@JSON
	@Override
	public String getUserName() {
		if (_userName == null) {
			return StringPool.BLANK;
		}
		else {
			return _userName;
		}
	}

	@Override
	public void setUserName(String userName) {
		_userName = userName;
	}

	@JSON
	@Override
	public Date getCreateDate() {
		return _createDate;
	}

	@Override
	public void setCreateDate(Date createDate) {
		_createDate = createDate;
	}

	@JSON
	@Override
	public Date getModifiedDate() {
		return _modifiedDate;
	}

	public boolean hasSetModifiedDate() {
		return _setModifiedDate;
	}

	@Override
	public void setModifiedDate(Date modifiedDate) {
		_setModifiedDate = true;

		_modifiedDate = modifiedDate;
	}

	@JSON
	@Override
	public String getType() {
		if (_type == null) {
			return StringPool.BLANK;
		}
		else {
			return _type;
		}
	}

	@Override
	public void setType(String type) {
		_type = type;
	}

	@JSON
	@Override
	public String getName() {
		if (_name == null) {
			return StringPool.BLANK;
		}
		else {
			return _name;
		}
	}

	@Override
	public void setName(String name) {
		_columnBitmask = -1L;

		if (_originalName == null) {
			_originalName = _name;
		}

		_name = name;
	}

	public String getOriginalName() {
		return GetterUtil.getString(_originalName);
	}

	@JSON
	@Override
	public int getNbColumns() {
		return _nbColumns;
	}

	@Override
	public void setNbColumns(int nbColumns) {
		_nbColumns = nbColumns;
	}

	@JSON
	@Override
	public int getNbRows() {
		return _nbRows;
	}

	@Override
	public void setNbRows(int nbRows) {
		_nbRows = nbRows;
	}

	@JSON
	@Override
	public String getImage() {
		if (_image == null) {
			return StringPool.BLANK;
		}
		else {
			return _image;
		}
	}

	@Override
	public void setImage(String image) {
		_image = image;
	}

	@JSON
	@Override
	public String getBottlesId() {
		if (_bottlesId == null) {
			return StringPool.BLANK;
		}
		else {
			return _bottlesId;
		}
	}

	@Override
	public void setBottlesId(String bottlesId) {
		_bottlesId = bottlesId;
	}

	@Override
	public StagedModelType getStagedModelType() {
		return new StagedModelType(PortalUtil.getClassNameId(
				Rack.class.getName()));
	}

	public long getColumnBitmask() {
		return _columnBitmask;
	}

	@Override
	public ExpandoBridge getExpandoBridge() {
		return ExpandoBridgeFactoryUtil.getExpandoBridge(getCompanyId(),
			Rack.class.getName(), getPrimaryKey());
	}

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		ExpandoBridge expandoBridge = getExpandoBridge();

		expandoBridge.setAttributes(serviceContext);
	}

	@Override
	public Rack toEscapedModel() {
		if (_escapedModel == null) {
			_escapedModel = (Rack)ProxyUtil.newProxyInstance(_classLoader,
					_escapedModelInterfaces, new AutoEscapeBeanHandler(this));
		}

		return _escapedModel;
	}

	@Override
	public Object clone() {
		RackImpl rackImpl = new RackImpl();

		rackImpl.setUuid(getUuid());
		rackImpl.setRackId(getRackId());
		rackImpl.setGroupId(getGroupId());
		rackImpl.setCompanyId(getCompanyId());
		rackImpl.setUserId(getUserId());
		rackImpl.setUserName(getUserName());
		rackImpl.setCreateDate(getCreateDate());
		rackImpl.setModifiedDate(getModifiedDate());
		rackImpl.setType(getType());
		rackImpl.setName(getName());
		rackImpl.setNbColumns(getNbColumns());
		rackImpl.setNbRows(getNbRows());
		rackImpl.setImage(getImage());
		rackImpl.setBottlesId(getBottlesId());

		rackImpl.resetOriginalValues();

		return rackImpl;
	}

	@Override
	public int compareTo(Rack rack) {
		int value = 0;

		value = getName().compareTo(rack.getName());

		if (value != 0) {
			return value;
		}

		return 0;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof Rack)) {
			return false;
		}

		Rack rack = (Rack)obj;

		long primaryKey = rack.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public boolean isEntityCacheEnabled() {
		return ENTITY_CACHE_ENABLED;
	}

	@Override
	public boolean isFinderCacheEnabled() {
		return FINDER_CACHE_ENABLED;
	}

	@Override
	public void resetOriginalValues() {
		RackModelImpl rackModelImpl = this;

		rackModelImpl._originalUuid = rackModelImpl._uuid;

		rackModelImpl._originalGroupId = rackModelImpl._groupId;

		rackModelImpl._setOriginalGroupId = false;

		rackModelImpl._originalCompanyId = rackModelImpl._companyId;

		rackModelImpl._setOriginalCompanyId = false;

		rackModelImpl._setModifiedDate = false;

		rackModelImpl._originalName = rackModelImpl._name;

		rackModelImpl._columnBitmask = 0;
	}

	@Override
	public CacheModel<Rack> toCacheModel() {
		RackCacheModel rackCacheModel = new RackCacheModel();

		rackCacheModel.uuid = getUuid();

		String uuid = rackCacheModel.uuid;

		if ((uuid != null) && (uuid.length() == 0)) {
			rackCacheModel.uuid = null;
		}

		rackCacheModel.rackId = getRackId();

		rackCacheModel.groupId = getGroupId();

		rackCacheModel.companyId = getCompanyId();

		rackCacheModel.userId = getUserId();

		rackCacheModel.userName = getUserName();

		String userName = rackCacheModel.userName;

		if ((userName != null) && (userName.length() == 0)) {
			rackCacheModel.userName = null;
		}

		Date createDate = getCreateDate();

		if (createDate != null) {
			rackCacheModel.createDate = createDate.getTime();
		}
		else {
			rackCacheModel.createDate = Long.MIN_VALUE;
		}

		Date modifiedDate = getModifiedDate();

		if (modifiedDate != null) {
			rackCacheModel.modifiedDate = modifiedDate.getTime();
		}
		else {
			rackCacheModel.modifiedDate = Long.MIN_VALUE;
		}

		rackCacheModel.type = getType();

		String type = rackCacheModel.type;

		if ((type != null) && (type.length() == 0)) {
			rackCacheModel.type = null;
		}

		rackCacheModel.name = getName();

		String name = rackCacheModel.name;

		if ((name != null) && (name.length() == 0)) {
			rackCacheModel.name = null;
		}

		rackCacheModel.nbColumns = getNbColumns();

		rackCacheModel.nbRows = getNbRows();

		rackCacheModel.image = getImage();

		String image = rackCacheModel.image;

		if ((image != null) && (image.length() == 0)) {
			rackCacheModel.image = null;
		}

		rackCacheModel.bottlesId = getBottlesId();

		String bottlesId = rackCacheModel.bottlesId;

		if ((bottlesId != null) && (bottlesId.length() == 0)) {
			rackCacheModel.bottlesId = null;
		}

		return rackCacheModel;
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(29);

		sb.append("{uuid=");
		sb.append(getUuid());
		sb.append(", rackId=");
		sb.append(getRackId());
		sb.append(", groupId=");
		sb.append(getGroupId());
		sb.append(", companyId=");
		sb.append(getCompanyId());
		sb.append(", userId=");
		sb.append(getUserId());
		sb.append(", userName=");
		sb.append(getUserName());
		sb.append(", createDate=");
		sb.append(getCreateDate());
		sb.append(", modifiedDate=");
		sb.append(getModifiedDate());
		sb.append(", type=");
		sb.append(getType());
		sb.append(", name=");
		sb.append(getName());
		sb.append(", nbColumns=");
		sb.append(getNbColumns());
		sb.append(", nbRows=");
		sb.append(getNbRows());
		sb.append(", image=");
		sb.append(getImage());
		sb.append(", bottlesId=");
		sb.append(getBottlesId());
		sb.append("}");

		return sb.toString();
	}

	@Override
	public String toXmlString() {
		StringBundler sb = new StringBundler(46);

		sb.append("<model><model-name>");
		sb.append("fr.ippon.services.embercellar.model.Rack");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>uuid</column-name><column-value><![CDATA[");
		sb.append(getUuid());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>rackId</column-name><column-value><![CDATA[");
		sb.append(getRackId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>groupId</column-name><column-value><![CDATA[");
		sb.append(getGroupId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>companyId</column-name><column-value><![CDATA[");
		sb.append(getCompanyId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userId</column-name><column-value><![CDATA[");
		sb.append(getUserId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userName</column-name><column-value><![CDATA[");
		sb.append(getUserName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>createDate</column-name><column-value><![CDATA[");
		sb.append(getCreateDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
		sb.append(getModifiedDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>type</column-name><column-value><![CDATA[");
		sb.append(getType());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>name</column-name><column-value><![CDATA[");
		sb.append(getName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>nbColumns</column-name><column-value><![CDATA[");
		sb.append(getNbColumns());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>nbRows</column-name><column-value><![CDATA[");
		sb.append(getNbRows());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>image</column-name><column-value><![CDATA[");
		sb.append(getImage());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>bottlesId</column-name><column-value><![CDATA[");
		sb.append(getBottlesId());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private static final ClassLoader _classLoader = Rack.class.getClassLoader();
	private static final Class<?>[] _escapedModelInterfaces = new Class[] {
			Rack.class
		};
	private String _uuid;
	private String _originalUuid;
	private long _rackId;
	private long _groupId;
	private long _originalGroupId;
	private boolean _setOriginalGroupId;
	private long _companyId;
	private long _originalCompanyId;
	private boolean _setOriginalCompanyId;
	private long _userId;
	private String _userName;
	private Date _createDate;
	private Date _modifiedDate;
	private boolean _setModifiedDate;
	private String _type;
	private String _name;
	private String _originalName;
	private int _nbColumns;
	private int _nbRows;
	private String _image;
	private String _bottlesId;
	private long _columnBitmask;
	private Rack _escapedModel;
}