/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.service.base;

import aQute.bnd.annotation.ProviderType;

import com.liferay.exportimport.kernel.lar.ExportImportHelperUtil;
import com.liferay.exportimport.kernel.lar.ManifestSummary;
import com.liferay.exportimport.kernel.lar.PortletDataContext;
import com.liferay.exportimport.kernel.lar.StagedModelDataHandlerUtil;
import com.liferay.exportimport.kernel.lar.StagedModelType;

import com.liferay.portal.kernel.bean.BeanReference;
import com.liferay.portal.kernel.dao.db.DB;
import com.liferay.portal.kernel.dao.db.DBManagerUtil;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdate;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdateFactoryUtil;
import com.liferay.portal.kernel.dao.orm.ActionableDynamicQuery;
import com.liferay.portal.kernel.dao.orm.DefaultActionableDynamicQuery;
import com.liferay.portal.kernel.dao.orm.DynamicQuery;
import com.liferay.portal.kernel.dao.orm.DynamicQueryFactoryUtil;
import com.liferay.portal.kernel.dao.orm.ExportActionableDynamicQuery;
import com.liferay.portal.kernel.dao.orm.IndexableActionableDynamicQuery;
import com.liferay.portal.kernel.dao.orm.Projection;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.model.PersistedModel;
import com.liferay.portal.kernel.module.framework.service.IdentifiableOSGiService;
import com.liferay.portal.kernel.search.Indexable;
import com.liferay.portal.kernel.search.IndexableType;
import com.liferay.portal.kernel.service.BaseLocalServiceImpl;
import com.liferay.portal.kernel.service.PersistedModelLocalServiceRegistry;
import com.liferay.portal.kernel.service.persistence.ClassNamePersistence;
import com.liferay.portal.kernel.service.persistence.UserPersistence;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.PortalUtil;
import com.liferay.portal.spring.extender.service.ServiceReference;

import fr.ippon.services.embercellar.model.Rack;
import fr.ippon.services.embercellar.service.RackLocalService;
import fr.ippon.services.embercellar.service.persistence.BottlePersistence;
import fr.ippon.services.embercellar.service.persistence.RackPersistence;

import java.io.Serializable;

import java.util.List;

import javax.sql.DataSource;

/**
 * Provides the base implementation for the rack local service.
 *
 * <p>
 * This implementation exists only as a container for the default service methods generated by ServiceBuilder. All custom service methods should be put in {@link fr.ippon.services.embercellar.service.impl.RackLocalServiceImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see fr.ippon.services.embercellar.service.impl.RackLocalServiceImpl
 * @see fr.ippon.services.embercellar.service.RackLocalServiceUtil
 * @generated
 */
@ProviderType
public abstract class RackLocalServiceBaseImpl extends BaseLocalServiceImpl
	implements RackLocalService, IdentifiableOSGiService {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. Always use {@link fr.ippon.services.embercellar.service.RackLocalServiceUtil} to access the rack local service.
	 */

	/**
	 * Adds the rack to the database. Also notifies the appropriate model listeners.
	 *
	 * @param rack the rack
	 * @return the rack that was added
	 */
	@Indexable(type = IndexableType.REINDEX)
	@Override
	public Rack addRack(Rack rack) {
		rack.setNew(true);

		return rackPersistence.update(rack);
	}

	/**
	 * Creates a new rack with the primary key. Does not add the rack to the database.
	 *
	 * @param rackId the primary key for the new rack
	 * @return the new rack
	 */
	@Override
	public Rack createRack(long rackId) {
		return rackPersistence.create(rackId);
	}

	/**
	 * Deletes the rack with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param rackId the primary key of the rack
	 * @return the rack that was removed
	 * @throws PortalException if a rack with the primary key could not be found
	 */
	@Indexable(type = IndexableType.DELETE)
	@Override
	public Rack deleteRack(long rackId) throws PortalException {
		return rackPersistence.remove(rackId);
	}

	/**
	 * Deletes the rack from the database. Also notifies the appropriate model listeners.
	 *
	 * @param rack the rack
	 * @return the rack that was removed
	 */
	@Indexable(type = IndexableType.DELETE)
	@Override
	public Rack deleteRack(Rack rack) {
		return rackPersistence.remove(rack);
	}

	@Override
	public DynamicQuery dynamicQuery() {
		Class<?> clazz = getClass();

		return DynamicQueryFactoryUtil.forClass(Rack.class,
			clazz.getClassLoader());
	}

	/**
	 * Performs a dynamic query on the database and returns the matching rows.
	 *
	 * @param dynamicQuery the dynamic query
	 * @return the matching rows
	 */
	@Override
	public <T> List<T> dynamicQuery(DynamicQuery dynamicQuery) {
		return rackPersistence.findWithDynamicQuery(dynamicQuery);
	}

	/**
	 * Performs a dynamic query on the database and returns a range of the matching rows.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link fr.ippon.services.embercellar.model.impl.RackModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param dynamicQuery the dynamic query
	 * @param start the lower bound of the range of model instances
	 * @param end the upper bound of the range of model instances (not inclusive)
	 * @return the range of matching rows
	 */
	@Override
	public <T> List<T> dynamicQuery(DynamicQuery dynamicQuery, int start,
		int end) {
		return rackPersistence.findWithDynamicQuery(dynamicQuery, start, end);
	}

	/**
	 * Performs a dynamic query on the database and returns an ordered range of the matching rows.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link fr.ippon.services.embercellar.model.impl.RackModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param dynamicQuery the dynamic query
	 * @param start the lower bound of the range of model instances
	 * @param end the upper bound of the range of model instances (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of matching rows
	 */
	@Override
	public <T> List<T> dynamicQuery(DynamicQuery dynamicQuery, int start,
		int end, OrderByComparator<T> orderByComparator) {
		return rackPersistence.findWithDynamicQuery(dynamicQuery, start, end,
			orderByComparator);
	}

	/**
	 * Returns the number of rows matching the dynamic query.
	 *
	 * @param dynamicQuery the dynamic query
	 * @return the number of rows matching the dynamic query
	 */
	@Override
	public long dynamicQueryCount(DynamicQuery dynamicQuery) {
		return rackPersistence.countWithDynamicQuery(dynamicQuery);
	}

	/**
	 * Returns the number of rows matching the dynamic query.
	 *
	 * @param dynamicQuery the dynamic query
	 * @param projection the projection to apply to the query
	 * @return the number of rows matching the dynamic query
	 */
	@Override
	public long dynamicQueryCount(DynamicQuery dynamicQuery,
		Projection projection) {
		return rackPersistence.countWithDynamicQuery(dynamicQuery, projection);
	}

	@Override
	public Rack fetchRack(long rackId) {
		return rackPersistence.fetchByPrimaryKey(rackId);
	}

	/**
	 * Returns the rack matching the UUID and group.
	 *
	 * @param uuid the rack's UUID
	 * @param groupId the primary key of the group
	 * @return the matching rack, or <code>null</code> if a matching rack could not be found
	 */
	@Override
	public Rack fetchRackByUuidAndGroupId(String uuid, long groupId) {
		return rackPersistence.fetchByUUID_G(uuid, groupId);
	}

	/**
	 * Returns the rack with the primary key.
	 *
	 * @param rackId the primary key of the rack
	 * @return the rack
	 * @throws PortalException if a rack with the primary key could not be found
	 */
	@Override
	public Rack getRack(long rackId) throws PortalException {
		return rackPersistence.findByPrimaryKey(rackId);
	}

	@Override
	public ActionableDynamicQuery getActionableDynamicQuery() {
		ActionableDynamicQuery actionableDynamicQuery = new DefaultActionableDynamicQuery();

		actionableDynamicQuery.setBaseLocalService(rackLocalService);
		actionableDynamicQuery.setClassLoader(getClassLoader());
		actionableDynamicQuery.setModelClass(Rack.class);

		actionableDynamicQuery.setPrimaryKeyPropertyName("rackId");

		return actionableDynamicQuery;
	}

	@Override
	public IndexableActionableDynamicQuery getIndexableActionableDynamicQuery() {
		IndexableActionableDynamicQuery indexableActionableDynamicQuery = new IndexableActionableDynamicQuery();

		indexableActionableDynamicQuery.setBaseLocalService(rackLocalService);
		indexableActionableDynamicQuery.setClassLoader(getClassLoader());
		indexableActionableDynamicQuery.setModelClass(Rack.class);

		indexableActionableDynamicQuery.setPrimaryKeyPropertyName("rackId");

		return indexableActionableDynamicQuery;
	}

	protected void initActionableDynamicQuery(
		ActionableDynamicQuery actionableDynamicQuery) {
		actionableDynamicQuery.setBaseLocalService(rackLocalService);
		actionableDynamicQuery.setClassLoader(getClassLoader());
		actionableDynamicQuery.setModelClass(Rack.class);

		actionableDynamicQuery.setPrimaryKeyPropertyName("rackId");
	}

	@Override
	public ExportActionableDynamicQuery getExportActionableDynamicQuery(
		final PortletDataContext portletDataContext) {
		final ExportActionableDynamicQuery exportActionableDynamicQuery = new ExportActionableDynamicQuery() {
				@Override
				public long performCount() throws PortalException {
					ManifestSummary manifestSummary = portletDataContext.getManifestSummary();

					StagedModelType stagedModelType = getStagedModelType();

					long modelAdditionCount = super.performCount();

					manifestSummary.addModelAdditionCount(stagedModelType,
						modelAdditionCount);

					long modelDeletionCount = ExportImportHelperUtil.getModelDeletionCount(portletDataContext,
							stagedModelType);

					manifestSummary.addModelDeletionCount(stagedModelType,
						modelDeletionCount);

					return modelAdditionCount;
				}
			};

		initActionableDynamicQuery(exportActionableDynamicQuery);

		exportActionableDynamicQuery.setAddCriteriaMethod(new ActionableDynamicQuery.AddCriteriaMethod() {
				@Override
				public void addCriteria(DynamicQuery dynamicQuery) {
					portletDataContext.addDateRangeCriteria(dynamicQuery,
						"modifiedDate");
				}
			});

		exportActionableDynamicQuery.setCompanyId(portletDataContext.getCompanyId());

		exportActionableDynamicQuery.setPerformActionMethod(new ActionableDynamicQuery.PerformActionMethod<Rack>() {
				@Override
				public void performAction(Rack rack) throws PortalException {
					StagedModelDataHandlerUtil.exportStagedModel(portletDataContext,
						rack);
				}
			});
		exportActionableDynamicQuery.setStagedModelType(new StagedModelType(
				PortalUtil.getClassNameId(Rack.class.getName())));

		return exportActionableDynamicQuery;
	}

	/**
	 * @throws PortalException
	 */
	@Override
	public PersistedModel deletePersistedModel(PersistedModel persistedModel)
		throws PortalException {
		return rackLocalService.deleteRack((Rack)persistedModel);
	}

	@Override
	public PersistedModel getPersistedModel(Serializable primaryKeyObj)
		throws PortalException {
		return rackPersistence.findByPrimaryKey(primaryKeyObj);
	}

	/**
	 * Returns all the racks matching the UUID and company.
	 *
	 * @param uuid the UUID of the racks
	 * @param companyId the primary key of the company
	 * @return the matching racks, or an empty list if no matches were found
	 */
	@Override
	public List<Rack> getRacksByUuidAndCompanyId(String uuid, long companyId) {
		return rackPersistence.findByUuid_C(uuid, companyId);
	}

	/**
	 * Returns a range of racks matching the UUID and company.
	 *
	 * @param uuid the UUID of the racks
	 * @param companyId the primary key of the company
	 * @param start the lower bound of the range of racks
	 * @param end the upper bound of the range of racks (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the range of matching racks, or an empty list if no matches were found
	 */
	@Override
	public List<Rack> getRacksByUuidAndCompanyId(String uuid, long companyId,
		int start, int end, OrderByComparator<Rack> orderByComparator) {
		return rackPersistence.findByUuid_C(uuid, companyId, start, end,
			orderByComparator);
	}

	/**
	 * Returns the rack matching the UUID and group.
	 *
	 * @param uuid the rack's UUID
	 * @param groupId the primary key of the group
	 * @return the matching rack
	 * @throws PortalException if a matching rack could not be found
	 */
	@Override
	public Rack getRackByUuidAndGroupId(String uuid, long groupId)
		throws PortalException {
		return rackPersistence.findByUUID_G(uuid, groupId);
	}

	/**
	 * Returns a range of all the racks.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link fr.ippon.services.embercellar.model.impl.RackModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param start the lower bound of the range of racks
	 * @param end the upper bound of the range of racks (not inclusive)
	 * @return the range of racks
	 */
	@Override
	public List<Rack> getRacks(int start, int end) {
		return rackPersistence.findAll(start, end);
	}

	/**
	 * Returns the number of racks.
	 *
	 * @return the number of racks
	 */
	@Override
	public int getRacksCount() {
		return rackPersistence.countAll();
	}

	/**
	 * Updates the rack in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	 *
	 * @param rack the rack
	 * @return the rack that was updated
	 */
	@Indexable(type = IndexableType.REINDEX)
	@Override
	public Rack updateRack(Rack rack) {
		return rackPersistence.update(rack);
	}

	/**
	 * Returns the bottle local service.
	 *
	 * @return the bottle local service
	 */
	public fr.ippon.services.embercellar.service.BottleLocalService getBottleLocalService() {
		return bottleLocalService;
	}

	/**
	 * Sets the bottle local service.
	 *
	 * @param bottleLocalService the bottle local service
	 */
	public void setBottleLocalService(
		fr.ippon.services.embercellar.service.BottleLocalService bottleLocalService) {
		this.bottleLocalService = bottleLocalService;
	}

	/**
	 * Returns the bottle persistence.
	 *
	 * @return the bottle persistence
	 */
	public BottlePersistence getBottlePersistence() {
		return bottlePersistence;
	}

	/**
	 * Sets the bottle persistence.
	 *
	 * @param bottlePersistence the bottle persistence
	 */
	public void setBottlePersistence(BottlePersistence bottlePersistence) {
		this.bottlePersistence = bottlePersistence;
	}

	/**
	 * Returns the rack local service.
	 *
	 * @return the rack local service
	 */
	public RackLocalService getRackLocalService() {
		return rackLocalService;
	}

	/**
	 * Sets the rack local service.
	 *
	 * @param rackLocalService the rack local service
	 */
	public void setRackLocalService(RackLocalService rackLocalService) {
		this.rackLocalService = rackLocalService;
	}

	/**
	 * Returns the rack persistence.
	 *
	 * @return the rack persistence
	 */
	public RackPersistence getRackPersistence() {
		return rackPersistence;
	}

	/**
	 * Sets the rack persistence.
	 *
	 * @param rackPersistence the rack persistence
	 */
	public void setRackPersistence(RackPersistence rackPersistence) {
		this.rackPersistence = rackPersistence;
	}

	/**
	 * Returns the counter local service.
	 *
	 * @return the counter local service
	 */
	public com.liferay.counter.kernel.service.CounterLocalService getCounterLocalService() {
		return counterLocalService;
	}

	/**
	 * Sets the counter local service.
	 *
	 * @param counterLocalService the counter local service
	 */
	public void setCounterLocalService(
		com.liferay.counter.kernel.service.CounterLocalService counterLocalService) {
		this.counterLocalService = counterLocalService;
	}

	/**
	 * Returns the class name local service.
	 *
	 * @return the class name local service
	 */
	public com.liferay.portal.kernel.service.ClassNameLocalService getClassNameLocalService() {
		return classNameLocalService;
	}

	/**
	 * Sets the class name local service.
	 *
	 * @param classNameLocalService the class name local service
	 */
	public void setClassNameLocalService(
		com.liferay.portal.kernel.service.ClassNameLocalService classNameLocalService) {
		this.classNameLocalService = classNameLocalService;
	}

	/**
	 * Returns the class name persistence.
	 *
	 * @return the class name persistence
	 */
	public ClassNamePersistence getClassNamePersistence() {
		return classNamePersistence;
	}

	/**
	 * Sets the class name persistence.
	 *
	 * @param classNamePersistence the class name persistence
	 */
	public void setClassNamePersistence(
		ClassNamePersistence classNamePersistence) {
		this.classNamePersistence = classNamePersistence;
	}

	/**
	 * Returns the resource local service.
	 *
	 * @return the resource local service
	 */
	public com.liferay.portal.kernel.service.ResourceLocalService getResourceLocalService() {
		return resourceLocalService;
	}

	/**
	 * Sets the resource local service.
	 *
	 * @param resourceLocalService the resource local service
	 */
	public void setResourceLocalService(
		com.liferay.portal.kernel.service.ResourceLocalService resourceLocalService) {
		this.resourceLocalService = resourceLocalService;
	}

	/**
	 * Returns the user local service.
	 *
	 * @return the user local service
	 */
	public com.liferay.portal.kernel.service.UserLocalService getUserLocalService() {
		return userLocalService;
	}

	/**
	 * Sets the user local service.
	 *
	 * @param userLocalService the user local service
	 */
	public void setUserLocalService(
		com.liferay.portal.kernel.service.UserLocalService userLocalService) {
		this.userLocalService = userLocalService;
	}

	/**
	 * Returns the user persistence.
	 *
	 * @return the user persistence
	 */
	public UserPersistence getUserPersistence() {
		return userPersistence;
	}

	/**
	 * Sets the user persistence.
	 *
	 * @param userPersistence the user persistence
	 */
	public void setUserPersistence(UserPersistence userPersistence) {
		this.userPersistence = userPersistence;
	}

	public void afterPropertiesSet() {
		persistedModelLocalServiceRegistry.register("fr.ippon.services.embercellar.model.Rack",
			rackLocalService);
	}

	public void destroy() {
		persistedModelLocalServiceRegistry.unregister(
			"fr.ippon.services.embercellar.model.Rack");
	}

	/**
	 * Returns the OSGi service identifier.
	 *
	 * @return the OSGi service identifier
	 */
	@Override
	public String getOSGiServiceIdentifier() {
		return RackLocalService.class.getName();
	}

	protected Class<?> getModelClass() {
		return Rack.class;
	}

	protected String getModelClassName() {
		return Rack.class.getName();
	}

	/**
	 * Performs a SQL query.
	 *
	 * @param sql the sql query
	 */
	protected void runSQL(String sql) {
		try {
			DataSource dataSource = rackPersistence.getDataSource();

			DB db = DBManagerUtil.getDB();

			sql = db.buildSQL(sql);
			sql = PortalUtil.transformSQL(sql);

			SqlUpdate sqlUpdate = SqlUpdateFactoryUtil.getSqlUpdate(dataSource,
					sql);

			sqlUpdate.update();
		}
		catch (Exception e) {
			throw new SystemException(e);
		}
	}

	@BeanReference(type = fr.ippon.services.embercellar.service.BottleLocalService.class)
	protected fr.ippon.services.embercellar.service.BottleLocalService bottleLocalService;
	@BeanReference(type = BottlePersistence.class)
	protected BottlePersistence bottlePersistence;
	@BeanReference(type = RackLocalService.class)
	protected RackLocalService rackLocalService;
	@BeanReference(type = RackPersistence.class)
	protected RackPersistence rackPersistence;
	@ServiceReference(type = com.liferay.counter.kernel.service.CounterLocalService.class)
	protected com.liferay.counter.kernel.service.CounterLocalService counterLocalService;
	@ServiceReference(type = com.liferay.portal.kernel.service.ClassNameLocalService.class)
	protected com.liferay.portal.kernel.service.ClassNameLocalService classNameLocalService;
	@ServiceReference(type = ClassNamePersistence.class)
	protected ClassNamePersistence classNamePersistence;
	@ServiceReference(type = com.liferay.portal.kernel.service.ResourceLocalService.class)
	protected com.liferay.portal.kernel.service.ResourceLocalService resourceLocalService;
	@ServiceReference(type = com.liferay.portal.kernel.service.UserLocalService.class)
	protected com.liferay.portal.kernel.service.UserLocalService userLocalService;
	@ServiceReference(type = UserPersistence.class)
	protected UserPersistence userPersistence;
	@ServiceReference(type = PersistedModelLocalServiceRegistry.class)
	protected PersistedModelLocalServiceRegistry persistedModelLocalServiceRegistry;
}