/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.service.base;

import com.liferay.portal.kernel.bean.BeanReference;
import com.liferay.portal.kernel.dao.db.DB;
import com.liferay.portal.kernel.dao.db.DBManagerUtil;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdate;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdateFactoryUtil;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.module.framework.service.IdentifiableOSGiService;
import com.liferay.portal.kernel.service.BaseServiceImpl;
import com.liferay.portal.kernel.service.persistence.ClassNamePersistence;
import com.liferay.portal.kernel.service.persistence.UserPersistence;
import com.liferay.portal.kernel.util.PortalUtil;
import com.liferay.portal.spring.extender.service.ServiceReference;

import fr.ippon.services.embercellar.model.Rack;
import fr.ippon.services.embercellar.service.RackService;
import fr.ippon.services.embercellar.service.persistence.BottlePersistence;
import fr.ippon.services.embercellar.service.persistence.RackPersistence;

import javax.sql.DataSource;

/**
 * Provides the base implementation for the rack remote service.
 *
 * <p>
 * This implementation exists only as a container for the default service methods generated by ServiceBuilder. All custom service methods should be put in {@link fr.ippon.services.embercellar.service.impl.RackServiceImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see fr.ippon.services.embercellar.service.impl.RackServiceImpl
 * @see fr.ippon.services.embercellar.service.RackServiceUtil
 * @generated
 */
public abstract class RackServiceBaseImpl extends BaseServiceImpl
	implements RackService, IdentifiableOSGiService {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. Always use {@link fr.ippon.services.embercellar.service.RackServiceUtil} to access the rack remote service.
	 */

	/**
	 * Returns the bottle local service.
	 *
	 * @return the bottle local service
	 */
	public fr.ippon.services.embercellar.service.BottleLocalService getBottleLocalService() {
		return bottleLocalService;
	}

	/**
	 * Sets the bottle local service.
	 *
	 * @param bottleLocalService the bottle local service
	 */
	public void setBottleLocalService(
		fr.ippon.services.embercellar.service.BottleLocalService bottleLocalService) {
		this.bottleLocalService = bottleLocalService;
	}

	/**
	 * Returns the bottle remote service.
	 *
	 * @return the bottle remote service
	 */
	public fr.ippon.services.embercellar.service.BottleService getBottleService() {
		return bottleService;
	}

	/**
	 * Sets the bottle remote service.
	 *
	 * @param bottleService the bottle remote service
	 */
	public void setBottleService(
		fr.ippon.services.embercellar.service.BottleService bottleService) {
		this.bottleService = bottleService;
	}

	/**
	 * Returns the bottle persistence.
	 *
	 * @return the bottle persistence
	 */
	public BottlePersistence getBottlePersistence() {
		return bottlePersistence;
	}

	/**
	 * Sets the bottle persistence.
	 *
	 * @param bottlePersistence the bottle persistence
	 */
	public void setBottlePersistence(BottlePersistence bottlePersistence) {
		this.bottlePersistence = bottlePersistence;
	}

	/**
	 * Returns the rack local service.
	 *
	 * @return the rack local service
	 */
	public fr.ippon.services.embercellar.service.RackLocalService getRackLocalService() {
		return rackLocalService;
	}

	/**
	 * Sets the rack local service.
	 *
	 * @param rackLocalService the rack local service
	 */
	public void setRackLocalService(
		fr.ippon.services.embercellar.service.RackLocalService rackLocalService) {
		this.rackLocalService = rackLocalService;
	}

	/**
	 * Returns the rack remote service.
	 *
	 * @return the rack remote service
	 */
	public RackService getRackService() {
		return rackService;
	}

	/**
	 * Sets the rack remote service.
	 *
	 * @param rackService the rack remote service
	 */
	public void setRackService(RackService rackService) {
		this.rackService = rackService;
	}

	/**
	 * Returns the rack persistence.
	 *
	 * @return the rack persistence
	 */
	public RackPersistence getRackPersistence() {
		return rackPersistence;
	}

	/**
	 * Sets the rack persistence.
	 *
	 * @param rackPersistence the rack persistence
	 */
	public void setRackPersistence(RackPersistence rackPersistence) {
		this.rackPersistence = rackPersistence;
	}

	/**
	 * Returns the counter local service.
	 *
	 * @return the counter local service
	 */
	public com.liferay.counter.kernel.service.CounterLocalService getCounterLocalService() {
		return counterLocalService;
	}

	/**
	 * Sets the counter local service.
	 *
	 * @param counterLocalService the counter local service
	 */
	public void setCounterLocalService(
		com.liferay.counter.kernel.service.CounterLocalService counterLocalService) {
		this.counterLocalService = counterLocalService;
	}

	/**
	 * Returns the class name local service.
	 *
	 * @return the class name local service
	 */
	public com.liferay.portal.kernel.service.ClassNameLocalService getClassNameLocalService() {
		return classNameLocalService;
	}

	/**
	 * Sets the class name local service.
	 *
	 * @param classNameLocalService the class name local service
	 */
	public void setClassNameLocalService(
		com.liferay.portal.kernel.service.ClassNameLocalService classNameLocalService) {
		this.classNameLocalService = classNameLocalService;
	}

	/**
	 * Returns the class name remote service.
	 *
	 * @return the class name remote service
	 */
	public com.liferay.portal.kernel.service.ClassNameService getClassNameService() {
		return classNameService;
	}

	/**
	 * Sets the class name remote service.
	 *
	 * @param classNameService the class name remote service
	 */
	public void setClassNameService(
		com.liferay.portal.kernel.service.ClassNameService classNameService) {
		this.classNameService = classNameService;
	}

	/**
	 * Returns the class name persistence.
	 *
	 * @return the class name persistence
	 */
	public ClassNamePersistence getClassNamePersistence() {
		return classNamePersistence;
	}

	/**
	 * Sets the class name persistence.
	 *
	 * @param classNamePersistence the class name persistence
	 */
	public void setClassNamePersistence(
		ClassNamePersistence classNamePersistence) {
		this.classNamePersistence = classNamePersistence;
	}

	/**
	 * Returns the resource local service.
	 *
	 * @return the resource local service
	 */
	public com.liferay.portal.kernel.service.ResourceLocalService getResourceLocalService() {
		return resourceLocalService;
	}

	/**
	 * Sets the resource local service.
	 *
	 * @param resourceLocalService the resource local service
	 */
	public void setResourceLocalService(
		com.liferay.portal.kernel.service.ResourceLocalService resourceLocalService) {
		this.resourceLocalService = resourceLocalService;
	}

	/**
	 * Returns the user local service.
	 *
	 * @return the user local service
	 */
	public com.liferay.portal.kernel.service.UserLocalService getUserLocalService() {
		return userLocalService;
	}

	/**
	 * Sets the user local service.
	 *
	 * @param userLocalService the user local service
	 */
	public void setUserLocalService(
		com.liferay.portal.kernel.service.UserLocalService userLocalService) {
		this.userLocalService = userLocalService;
	}

	/**
	 * Returns the user remote service.
	 *
	 * @return the user remote service
	 */
	public com.liferay.portal.kernel.service.UserService getUserService() {
		return userService;
	}

	/**
	 * Sets the user remote service.
	 *
	 * @param userService the user remote service
	 */
	public void setUserService(
		com.liferay.portal.kernel.service.UserService userService) {
		this.userService = userService;
	}

	/**
	 * Returns the user persistence.
	 *
	 * @return the user persistence
	 */
	public UserPersistence getUserPersistence() {
		return userPersistence;
	}

	/**
	 * Sets the user persistence.
	 *
	 * @param userPersistence the user persistence
	 */
	public void setUserPersistence(UserPersistence userPersistence) {
		this.userPersistence = userPersistence;
	}

	public void afterPropertiesSet() {
	}

	public void destroy() {
	}

	/**
	 * Returns the OSGi service identifier.
	 *
	 * @return the OSGi service identifier
	 */
	@Override
	public String getOSGiServiceIdentifier() {
		return RackService.class.getName();
	}

	protected Class<?> getModelClass() {
		return Rack.class;
	}

	protected String getModelClassName() {
		return Rack.class.getName();
	}

	/**
	 * Performs a SQL query.
	 *
	 * @param sql the sql query
	 */
	protected void runSQL(String sql) {
		try {
			DataSource dataSource = rackPersistence.getDataSource();

			DB db = DBManagerUtil.getDB();

			sql = db.buildSQL(sql);
			sql = PortalUtil.transformSQL(sql);

			SqlUpdate sqlUpdate = SqlUpdateFactoryUtil.getSqlUpdate(dataSource,
					sql);

			sqlUpdate.update();
		}
		catch (Exception e) {
			throw new SystemException(e);
		}
	}

	@BeanReference(type = fr.ippon.services.embercellar.service.BottleLocalService.class)
	protected fr.ippon.services.embercellar.service.BottleLocalService bottleLocalService;
	@BeanReference(type = fr.ippon.services.embercellar.service.BottleService.class)
	protected fr.ippon.services.embercellar.service.BottleService bottleService;
	@BeanReference(type = BottlePersistence.class)
	protected BottlePersistence bottlePersistence;
	@BeanReference(type = fr.ippon.services.embercellar.service.RackLocalService.class)
	protected fr.ippon.services.embercellar.service.RackLocalService rackLocalService;
	@BeanReference(type = RackService.class)
	protected RackService rackService;
	@BeanReference(type = RackPersistence.class)
	protected RackPersistence rackPersistence;
	@ServiceReference(type = com.liferay.counter.kernel.service.CounterLocalService.class)
	protected com.liferay.counter.kernel.service.CounterLocalService counterLocalService;
	@ServiceReference(type = com.liferay.portal.kernel.service.ClassNameLocalService.class)
	protected com.liferay.portal.kernel.service.ClassNameLocalService classNameLocalService;
	@ServiceReference(type = com.liferay.portal.kernel.service.ClassNameService.class)
	protected com.liferay.portal.kernel.service.ClassNameService classNameService;
	@ServiceReference(type = ClassNamePersistence.class)
	protected ClassNamePersistence classNamePersistence;
	@ServiceReference(type = com.liferay.portal.kernel.service.ResourceLocalService.class)
	protected com.liferay.portal.kernel.service.ResourceLocalService resourceLocalService;
	@ServiceReference(type = com.liferay.portal.kernel.service.UserLocalService.class)
	protected com.liferay.portal.kernel.service.UserLocalService userLocalService;
	@ServiceReference(type = com.liferay.portal.kernel.service.UserService.class)
	protected com.liferay.portal.kernel.service.UserService userService;
	@ServiceReference(type = UserPersistence.class)
	protected UserPersistence userPersistence;
}