/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package fr.ippon.services.embercellar.service.http;

import aQute.bnd.annotation.ProviderType;

import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;

import fr.ippon.services.embercellar.service.RackServiceUtil;

import java.rmi.RemoteException;

/**
 * Provides the SOAP utility for the
 * {@link RackServiceUtil} service utility. The
 * static methods of this class calls the same methods of the service utility.
 * However, the signatures are different because it is difficult for SOAP to
 * support certain types.
 *
 * <p>
 * ServiceBuilder follows certain rules in translating the methods. For example,
 * if the method in the service utility returns a {@link java.util.List}, that
 * is translated to an array of {@link fr.ippon.services.embercellar.model.RackSoap}.
 * If the method in the service utility returns a
 * {@link fr.ippon.services.embercellar.model.Rack}, that is translated to a
 * {@link fr.ippon.services.embercellar.model.RackSoap}. Methods that SOAP cannot
 * safely wire are skipped.
 * </p>
 *
 * <p>
 * The benefits of using the SOAP utility is that it is cross platform
 * compatible. SOAP allows different languages like Java, .NET, C++, PHP, and
 * even Perl, to call the generated services. One drawback of SOAP is that it is
 * slow because it needs to serialize all calls into a text format (XML).
 * </p>
 *
 * <p>
 * You can see a list of services at http://localhost:8080/api/axis. Set the
 * property <b>axis.servlet.hosts.allowed</b> in portal.properties to configure
 * security.
 * </p>
 *
 * <p>
 * The SOAP utility is only generated for remote services.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see RackServiceHttp
 * @see fr.ippon.services.embercellar.model.RackSoap
 * @see RackServiceUtil
 * @generated
 */
@ProviderType
public class RackServiceSoap {
	public static fr.ippon.services.embercellar.model.RackSoap addRack(
		java.lang.String name, int nbColumns, int nbRows,
		java.lang.String pathImg,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws RemoteException {
		try {
			fr.ippon.services.embercellar.model.Rack returnValue = RackServiceUtil.addRack(name,
					nbColumns, nbRows, pathImg, serviceContext);

			return fr.ippon.services.embercellar.model.RackSoap.toSoapModel(returnValue);
		}
		catch (Exception e) {
			_log.error(e, e);

			throw new RemoteException(e.getMessage());
		}
	}

	/**
	* NOTE FOR DEVELOPERS:
	*
	* Never reference this class directly. Always use {@link RackServiceUtil} to access the rack remote service.
	*/
	public static fr.ippon.services.embercellar.model.RackSoap[] findAll()
		throws RemoteException {
		try {
			java.util.List<fr.ippon.services.embercellar.model.Rack> returnValue =
				RackServiceUtil.findAll();

			return fr.ippon.services.embercellar.model.RackSoap.toSoapModels(returnValue);
		}
		catch (Exception e) {
			_log.error(e, e);

			throw new RemoteException(e.getMessage());
		}
	}

	public static fr.ippon.services.embercellar.model.RackSoap findByRackId(
		long rackId) throws RemoteException {
		try {
			fr.ippon.services.embercellar.model.Rack returnValue = RackServiceUtil.findByRackId(rackId);

			return fr.ippon.services.embercellar.model.RackSoap.toSoapModel(returnValue);
		}
		catch (Exception e) {
			_log.error(e, e);

			throw new RemoteException(e.getMessage());
		}
	}

	private static Log _log = LogFactoryUtil.getLog(RackServiceSoap.class);
}